package gui;
import java.awt.Point;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

/**
 * Code to respond to Zoom in by clicking on the Corruption Diagram.
 * First the co-ordinates of the point where the user has clicked are determined, if they are within the boundaries
 * of the frame, then the Quadrant is determined and the appropriate range for valid time and transaction time axes 
 * are set in the GNUPlot script. The Corruption event is then redrawn to display the zoomed image
 * 
 * @author Natasha Gaitonde - gaitonde@email.arizona.edu
 *
 */

public class CSIMAC extends MouseAdapter 
{
	CSIPlotMain cpm;//Reference to the calling CSIPlot Main object
	int level = 0;//Zoom in level
	CSIMAC (CSIPlotMain cpmRef)
	{
		cpm = cpmRef;
	}
	public void mousePressed(MouseEvent e)
	{
		Point p = e.getPoint();
		if(p.x>=155 && p.x<=625 && p.y>=40 && p.y<=480)//Within screen limits
		{
			level++;
			if(p.x<=390 && p.y>260)//1st Quadrant
			{
				cpm.gnuPlotScript(level,1);
				cpm.drawImage();
			}
			else if(p.x>390 && p.y>260)//Second Quadrant
			{
				cpm.gnuPlotScript(level,2);
				cpm.drawImage();
			}
			else if(p.x<=390 && p.y<=260)//Third Quadrant
			{
				cpm.gnuPlotScript(level,3);
				cpm.drawImage();
			}
			else if(p.x>390 && p.y<=260)//Fourth Quadrant
			{
				cpm.gnuPlotScript(level,4);
				cpm.drawImage();
			}
		}
	}
}