package gui;
import java.sql.Timestamp;
import java.text.SimpleDateFormat;

/**
 * Wrapper object for Timestamps to plot the corruption regions. This is needed for zooming. 
 * the zi object contains the timestamps of the most recent zoom in. the zo HashMap contains entries for all previous
 * zoom ins so that we can zoom out
 * 
 * @author Natasha Gaitonde - gaitonde@email.arizona.edu
 *
 */
public class CSITSWrapper 
{
	Timestamp xlow, xhigh, ylow, yhigh;
	CSITSWrapper()
	{}

	CSITSWrapper(Timestamp xl, Timestamp xh, Timestamp yl, Timestamp yh)
	{
		xlow=new Timestamp(xl.getTime());
		xhigh=new Timestamp(xh.getTime());
		ylow=new Timestamp(yl.getTime());
		yhigh=new Timestamp(yh.getTime());
	}	

	void makeEqual(CSITSWrapper cw)//As timestamps are objects, we only want to copy the value
	{
		xlow=new Timestamp(cw.xlow.getTime());
		xhigh=new Timestamp(cw.xhigh.getTime());
		ylow=new Timestamp(cw.ylow.getTime());
		yhigh=new Timestamp(cw.yhigh.getTime());
	}
	public Timestamp getXhigh() 
	{
		return xhigh;
	}
	public void setXhigh(long xhigh) 
	{
		this.xhigh.setTime(xhigh);
	}
	public Timestamp getXlow() 
	{
		return xlow;
	}
	public void setXlow(long xlow) 
	{
		this.xlow.setTime(xlow);
	}
	public Timestamp getYhigh() 
	{
		return yhigh;
	}
	public void setYhigh(long yhigh) 
	{
		this.yhigh.setTime(yhigh);
	}
	public Timestamp getYlow() 
	{
		return ylow;
	}
	public void setYlow(long ylow) 
	{
		this.ylow.setTime(ylow);
	}	
}