#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netdb.h>



void RGBYPartialChain(SQLHDBC dbc, char *server, in_port_t port) 
{
    int i,d;

    int sum,length;    

    char hash_value[AUD_HASH_LEN];
    NID rnid;
    
    int granule = getCurNotGranule(dbc);

printf("\ngetCurNotGranule:%d\n",granule);


printf(" need add more partial chains\n");

    d = 0;
    while (1) {

	sum = A3DgetPower(d);

  	if (granule % sum  == 0 && granule % (sum*2) != 0 ) {
	    break;
	}
        d++;
    }
printf("got integer d is %d\n",d);

    // add chain with length from 1,2,4,8,....,2tod
    if (d > 0 && A3DpowerOf2(granule)) {
	d--;
    }

printf("Final integer d is %d\n",d);

    //char prevactualdate[DATELEN],prevactualtime[DATELEN], prevactualms[MSLEN];
    char stopSchDate[TIMESTPLEN],stopActDate[TIMESTPLEN],stopactualms[MSLEN];
    char startSchDate[TIMESTPLEN],startActDate[TIMESTPLEN],startactualms[MSLEN];

    char maxPreNotID[IDLEN];
    char stopNotID[IDLEN];

    // given current stop Date
    getStop(dbc,stopSchDate,stopActDate,stopactualms,maxPreNotID);
printf("\nStop scheduled date:%s,stopActDate:%s,eventID:%s\n",stopSchDate,stopActDate,maxPreNotID);

    i = 0;
    while (i <= d) {
	//length = A3DgetPower(i);
printf("add the [%d] chain for length[%d]\n",i, length);

	getChainStart(dbc,i,maxPreNotID,startSchDate,startActDate,startactualms);
printf("\nStart scheduled date:%s,startActDate:%s\n",startSchDate,startActDate);

	rnid = A3DcalChainNID(dbc,startActDate,startactualms,stopActDate,stopactualms,server,port,hash_value);

//printf("This chain hashvalue:\n");
//print_hash(rnid.nid);

	A3DinsertChain(dbc,startActDate,startactualms,stopActDate,stopactualms,hash_value, rnid);
	i++;
    }
    
    // add the delayed chain

    getPreNotID(dbc,stopNotID, maxPreNotID);

    getChainStart(dbc,0,stopNotID,startSchDate,startActDate,startactualms);

getPreNotEvent(dbc, stopNotID,stopSchDate, stopActDate, stopactualms, maxPreNotID);

    rnid = A3DcalChainNID(dbc,startActDate,startactualms,stopActDate,stopactualms,server,port, hash_value);

    A3DinsertChain(dbc,startActDate,startactualms,stopActDate,stopactualms,hash_value, rnid);
   
printf("insert one delayed chain\n");
}



// insert a partial chain into Chain table
void A3DinsertChain(SQLHDBC dbc, char *startActDate, char *startactualms, char *stopActDate, char *stopactualms,char *hash_value, NID nid) 
{
    int i;

    SQLCHAR insChain[MAXINSLEN] = "insert into Chain (EventID,Color,StartDate,StartMilliseconds,Hashcode,NotarID,StopDate,StopMilliseconds) VALUES (";

    char tempstr[AUD_HASH_LEN];

    char curValEventID[IDLEN];

    getMaxValID(dbc,curValEventID);
    strcat(insChain,curValEventID);
    strcat(insChain,",'A3D_P','");

    strcat(insChain,startActDate);
    strcat(insChain,"',");
    strcat(insChain,startactualms);
    strcat(insChain,",'");

    // HashCode
    for (i=0; i<AUD_HASH_LEN; i++)
    {
        sprintf(tempstr,"%02X", 0xff & hash_value[i]);
        strcat(insChain,tempstr);
    }
    strcat(insChain,"','");

    //transfer NID into hashvalue(char)
    for (i=0; i<AUD_HASH_LEN; i++)
    {
        sprintf(tempstr,"%02X", 0xff & nid.nid[i]);
        strcat(insChain,tempstr);
    }
    //printf("*********tempstr:%s\n",tempstr);
    strcat(insChain,"','");

    strcat(insChain,stopActDate);
    strcat(insChain,"',");
    strcat(insChain,stopactualms);

    strcat(insChain,")");

printf("A3D insert partial Chain:[%s]\n",insChain);
    // insert tuple into Chain table
    exeSqlQuery(dbc,insChain);

printf("Insert one A3d partial chain for validator\n");


}

//
// calculate hash value given time range(start,stop) 
// insert into Chain table for this chain value
//
NID A3DcalChainNID(SQLHDBC dbc, char *startActDate, char *startActMs, char *stopActDate, char *stopActMs, char *server, in_port_t port, char *hash_value)
{
    VER_TOL_ENTRY *p;
    AUD_TXN_HASH_DATA txn_hash_data;
    rb_red_blk_node *np;


    struct timeval stime,ttime;
//    struct timeval start_time;

    char stopactualdate[DATELEN],stopactualtime[DATELEN];
    char startactualdate[DATELEN],startactualtime[DATELEN];

    NID rnid;

    int sockfd;
    struct hostent *serv_p;
    SAI servaddr;
    int n;

    printf("Begin calculate partial chain hashing.\n");

    np = RBMin(tree);
    p = (np == NULL)? NULL: (VER_TOL_ENTRY *)(np->info);
    memset(hash_value, 0, AUD_HASH_LEN);

    // set the start time for this partial chain 
    getDate(startActDate,startactualdate,startactualtime);
    stime = mkCalTime(startactualdate,startactualtime,startActMs);
    printf("\nCalculate partial chain hash value start time(%d,%d), %s\n",stime.tv_sec,stime.tv_usec,startActDate);

    // Rechain the txn's in TOL till the tail time "ttime"
    // locate the start txn

    while (p != NULL) {
        if (time_cmp(p->time, stime) >= 0)
            break;

        printf("TOL:jump txn_time(%d,%d)\n",
                   p->time.tv_sec, p->time.tv_usec);

        printf("    jump hash_value = ");
        print_hash(hash_value);

        printf("    jump txn_hash =");
        print_hash(p->hash_value);

        np = TreeSuccessor(tree, np);

        if (tree->nil == np ) {
            break;
        }
        p = (np == NULL)? NULL: (VER_TOL_ENTRY *)(np->info);
    }

    // set the stop time for this partial chain 
    getDate(stopActDate,stopactualdate,stopactualtime);
    ttime = mkCalTime(stopactualdate,stopactualtime,stopActMs);
    printf("\nCalculate partial chain hash value until time(%d,%d) %s\n",ttime.tv_sec,ttime.tv_usec,stopActDate);


    while (p != NULL && np != tree->nil) {
        if (time_cmp(p->time, ttime) >= 0)
            break;
        printf("TOL:txn_time(%d,%d)\n",
                   p->time.tv_sec, p->time.tv_usec);

        printf("    start hash_value = ");
        print_hash(hash_value);

        printf("    txn_hash =");
        print_hash(p->hash_value);

        memcpy(txn_hash_data.prev_hash_value, hash_value, AUD_HASH_LEN);
        txn_hash_data.time = p->time;
        memcpy(txn_hash_data.hash_value, p->hash_value, AUD_HASH_LEN);
        if (__aud_hash(&txn_hash_data, sizeof(AUD_TXN_HASH_DATA), hash_value) != 0) {
            insErrEvent(dbc,"Error in call __aud_hash API!");
            fprintf(stderr,"Error in call __aud_hash API!");
            exit(1);
        }


        printf("    tail_hash=");
        print_hash(hash_value);

        np = TreeSuccessor(tree, np);

        if (tree->nil == np ) {
            break;
        }
        p = (np == NULL)? NULL: (VER_TOL_ENTRY *)(np->info);
    }


    // store hash_value
    // send hash value to surety to get NotarID
    /* Establish UDP */

    memset(&servaddr, 0, sizeof(servaddr));
    servaddr.sin_family = AF_INET;
    servaddr.sin_port = htons(port);

    serv_p = gethostbyname(server);
    bcopy(serv_p->h_addr, &servaddr.sin_addr, serv_p->h_length);
    sockfd = socket(AF_INET, SOCK_DGRAM, 0);

    sendto(sockfd, hash_value, AUD_HASH_LEN, 0,
                (SA *)&servaddr, sizeof(servaddr));

    printf("Request sent: \n");
    print_hash(hash_value);

    n = recvfrom(sockfd, &rnid, sizeof(rnid), 0, NULL, NULL);
    printf("    N-id received:\n");
    print_hash(rnid.nid);

    return rnid;

}

