#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netdb.h>

#include "a3d.h"

/* TT support */
/*
typedef struct timeval TV;
#include "shqueue.h"
#include "db_int.h"
#include "aud_int.h"
#include "heap.h"
*/

/*BEECRYPT support*/
//#include "sha1.h"

#define MAX_CORRUPT 10

typedef struct sockaddr SA;

typedef struct sockaddr_in SAI;


struct __ver_tol_entry {
    //TV time;
    struct timeval time;
    char hash_value[AUD_HASH_LEN];
    void *hash_param; /* hash function state */
    Heap_T tuple_heap; /* priority queue */
    int expected_seq; /* next expected sequence number */
    /*struct __ver_tol_entry *next;*/
};
typedef struct __ver_tol_entry VER_TOL_ENTRY;

#define time_cmp(at, bt) ((at.tv_sec==bt.tv_sec)? (at.tv_usec-bt.tv_usec): (at.tv_sec-bt.tv_sec))


extern rb_red_blk_tree *tree;

void show_a3d_error() {
  fprintf(stderr, "err in a3d!\n");
  exit(1);
}

void A3DForensic(SQLHDBC dbc, char *server, in_port_t port,  char *maxNotID)
{
    int Cset[MAX_CORRUPT];

    int topCpt = 0;
    int min;

    int D,height;
    double temp,temph;

    D = getCurNotGranule(dbc);

    temp = log(D)/log(2);   

    modf(temp,&temph);

    height = (int)temph + 1;

    A3Dhelper(dbc,'B',A3DgetPower(height),0,height,Cset,&topCpt,server,port);    

    // decide corruption region
    int LTB,UTB,LSB,USB;

    char LTBID[IDLEN],UTBID[IDLEN],LSBID[IDLEN],USBID[IDLEN];


    char curTamperID[IDLEN];

    // get current Tampering ID
    getTamperID(dbc,curTamperID);

    if (topCpt == 0) {
	//triangle
	USB = D;
	LSB = D - ConfigTable.VFactor;

        LTB = D - ConfigTable.VFactor;
	UTB = D;

        A3DgetNotID(dbc,LTBID,LTB);
        A3DgetNotID(dbc,UTBID,UTB);

	A3DgetNotID(dbc,LSBID,LSB);
    	A3DgetNotID(dbc,USBID,USB);

printf("LTB[%d],UTB[%d],LSB[%d],USB[%d]\n",LTB,UTB,LSB,USB);
printf("LTBID[%s],UTBID[%s],LSBID[%s],USBID[%s]\n",LTBID,UTBID,LSBID,USBID);

        WriteSynRegion(dbc,curTamperID,LSBID,UTBID,USBID,UTBID,LSBID,LTBID,USBID,UTBID);
    }

    else {
        min = Cset[0];

    	if (min < D - ConfigTable.VFactor) {
	    LTB = D - ConfigTable.VFactor;
        }
    	else LTB = min;

    	UTB = D;

        A3DgetNotID(dbc,LTBID,LTB);
        A3DgetNotID(dbc,UTBID,UTB);

    	int i = 0;

    	while (i < topCpt) {

            USB = Cset[i];

  	    LSB = USB - 1;

printf("LTB[%d],UTB[%d],LSB[%d],USB[%d]\n",LTB,UTB,LSB,USB);

    	    A3DgetNotID(dbc,LSBID,LSB);
    	    A3DgetNotID(dbc,USBID,USB);

printf("LTBID[%s],UTBID[%s],LSBID[%s],USBID[%s]\n",LTBID,UTBID,LSBID,USBID);

            WriteSynRegion(dbc,curTamperID,LSBID,UTBID,USBID,UTBID,LSBID,LTBID,USBID,LTBID);

	    i++;
    	}
    }
}


printCset(int *Cset,int *topCpt)
{
    int i;

    printf("----Cset----\n");

    if (*topCpt == 0) {
	printf("Empty\n");
	return;
    }

    for(i=0;i<*topCpt;i++)
	printf("Cset[%d]:%d\t",i,Cset[i]);

    printf("\n");
}



void A3Dhelper(SQLHDBC dbc,char chaintype,int subscript, int superscript, int Cheight, int *Cset, int *topCpt, char *server, in_port_t port)
{
    int newsub;
    char chainID[IDLEN];
printf("A3Dhelper,chaingtype[%c],subscript[%d],superscript[%d],height[%d]\n",chaintype,subscript,superscript,Cheight);
printCset(Cset,topCpt);

    if (Cheight == 0) {
 	if (A3DexistChain(dbc,chaintype,subscript,superscript,chainID)) {
	    if (!A3DvalCheckChain(dbc,chaintype,chainID,server, port)) {
		Cset[(*topCpt)++] = subscript;
printf("height is 0,insert [%d] into Cset,current subscript [%d]\n",subscript,subscript);
	    }
	    return;
        }
    } 
    else if (!A3DexistChain(dbc,chaintype,subscript,superscript,chainID) || 
		!A3DvalCheckChain(dbc,chaintype,chainID,server,port)) {
		//!( A3DvalCheckChain(dbc,chaintype,chainID,server,port) && chaintype == 'B')) {

	    Cheight--;

	    if (chaintype == 'B') {
		if (Cheight == 0) {
		    A3Dhelper(dbc,'P',subscript/2,0,Cheight,Cset,topCpt,server,port);
		}
		else {
		    A3Dhelper(dbc,'B',subscript/2,0,Cheight,Cset,topCpt,server,port);
		}
		//A3Dhelper(dbc,'P',subscript,0,Cheight,Cset,topCpt,server,port);
		A3Dhelper(dbc,'P',subscript,superscript+Cheight,Cheight,Cset,topCpt,server,port);

	    }
	    else if (chaintype == 'P') {
		newsub = (2 * subscript - A3DgetPower(Cheight+1))/2;

printf("A3Dhelper,P chain newsub is [%d],oldsub is [%d],new height is [%d]\n",newsub,subscript,Cheight);

		//A3Dhelper(dbc,'P',newsub,superscript,Cheight,Cset,topCpt,server,port);
		//A3Dhelper(dbc,'P',subscript,superscript+1,Cheight,Cset,topCpt,server,port);
		A3Dhelper(dbc,'P',newsub,Cheight,Cheight,Cset,topCpt,server,port);
		A3Dhelper(dbc,'P',subscript,Cheight,Cheight,Cset,topCpt,server,port);
	    }
	}
}

int A3DexistChain(SQLHDBC dbc,char chaintype,int subscript, int superscript,char *chainID)
{
    char stopSchDate[TIMESTPLEN],stopActDate[TIMESTPLEN],stopActMs[MSLEN];
    char startSchDate[TIMESTPLEN],startActDate[TIMESTPLEN],startactualms[MSLEN];

    char stopNotID[IDLEN],stopValID[IDLEN];

    int granule = getCurNotGranule(dbc);

printf("A3DexistChain parameter,chaintype[%c],subscript[%d],supterscript[%d]\n",chaintype,subscript,superscript);

printf("A3DexistChain,granule[%d]\n",granule);

    if (subscript > granule) {
	printf("Chain not exist!!\n");
	return 0;
    }

    // get the stop Notarization EventID according to subscript
    A3DgetNotID(dbc,stopNotID,subscript);

    // get the stop Validation EventID according to the corresponding notarization EventID
    A3DgetValID(dbc,stopValID,stopNotID);

printf("A3DexistChain,stop ValID[%s],stop NotID[%s]\n",stopValID,stopNotID);

    if (chaintype == 'B') {
	// it's a black chain

 	getTimestp(startActDate,ConfigTable.StartDate,ConfigTable.StartTime);

	getEventDate(dbc, stopNotID, stopActDate, stopActMs);

  	// search for this chain
	return IsChainExist(dbc,"black",stopNotID,startActDate,"0",stopActDate,stopActMs,chainID);
    }
    else if (chaintype == 'P') {
	// it's a partial chain
    	// get the start time according to subscript
    	getChainStart(dbc,superscript,stopNotID,startSchDate,startActDate,startactualms);

	getEventDate(dbc, stopNotID, stopActDate, stopActMs);

printf("A3DexistChain,startSchDate[%s],startActDate[%s],startactualms[%s]\n",startSchDate,startActDate,startactualms);

  	// search for this chain
	return IsChainExist(dbc,"A3D_P",stopValID,startActDate,startactualms,stopActDate,stopActMs,chainID);

    }

}


// get Notarizaiton EventID for given subscript(chain stop day/time)
void A3DgetNotID(SQLHDBC dbc, char *stopNotID, int subscript)
{
    int curGel;
    char preNotID[IDLEN],curNotID[IDLEN],maxNotID[IDLEN];

    curGel = getCurNotGranule(dbc);

//printf("A3DgetNotID,current Not granule[%d],subscript[%d]\n",curGel,subscript);

    // get maximum Notarization EventID
    getMaxNotID(dbc,maxNotID);

    // get current active Notarization EventID
    getPreNotID(dbc,curNotID,maxNotID);

    bzero(preNotID,IDLEN);
    strcpy(preNotID,curNotID);

    while (curGel-- > subscript) {
	getPreNotID(dbc,preNotID,curNotID);
	bzero(curNotID,IDLEN);
	strcpy(curNotID,preNotID);

    }
	
    bzero(stopNotID,IDLEN);
    strcpy(stopNotID,preNotID);

//printf("A3DgetNotID,preNotID[%s]\n",preNotID);
}


// recalculate the hash value for given chain
int A3DvalCheckChain(SQLHDBC dbc, char chaintype, char *chainID, char *server, in_port_t port)
{
    VER_TOL_ENTRY *p;
    AUD_TXN_HASH_DATA txn_hash_data;
    rb_red_blk_node *np;


    struct timeval stime,ttime;
    //struct timeval start_time;

    char stopactualdate[DATELEN],stopactualtime[DATELEN];
    char startactualdate[DATELEN],startactualtime[DATELEN];
    char startActDate[TIMESTPLEN],startActMs[MSLEN];
    char stopActDate[TIMESTPLEN],stopActMs[MSLEN];

    NID rnid,onid;

    int sockfd;
    struct hostent *serv_p;
    SAI servaddr;
    int n;

    char eventID[IDLEN];

    char hash_value[AUD_HASH_LEN];


    printf("A3DvalCheckChain,Begin recalculate partial chain hashing.\n");

    printf("A3DvalCheckChain parameter,chainID[%s]\n",chainID);

    np = RBMin(tree);
    p = (np == NULL)? NULL: (VER_TOL_ENTRY *)(np->info);
    memset(hash_value, 0, AUD_HASH_LEN);

    // set the start time for this partial chain
    getChainInfo(dbc,startActDate,startActMs,stopActDate,stopActMs,eventID,chainID); // get the start time
    printf("A3DvalCheckChain chaininfo:startActDate[%s],startActMs[%s],stopActDate[%s],stopActMs[%s],EventID[%s],ChainID[%s]\n",startActDate,startActMs,stopActDate,stopActMs,eventID,chainID);

    getDate(startActDate,startactualdate,startactualtime); // change the time format

    stime = mkCalTime(startactualdate,startactualtime,startActMs);

    printf("\nReCalculate partial chain hash value start time(%d,%d)\n",stime.tv_sec,stime.tv_usec);

    // Rechain the txn's in TOL till the tail time "ttime"
    // locate the start txn

    while (p != NULL) {
        if (time_cmp(p->time, stime) >= 0)
            break;

        printf("TOL:jump txn_time(%d,%d)\n",
                   p->time.tv_sec, p->time.tv_usec);

        printf("    jump start hash_value = ");
        print_hash(hash_value);

        printf("    jump txn_hash =");
        print_hash(p->hash_value);

        np = TreeSuccessor(tree, np);

        if (tree->nil == np ) {
            break;
        }
        p = (np == NULL)? NULL: (VER_TOL_ENTRY *)(np->info);
    } 

    // set the stop time for this partial chain
    getDate(stopActDate,stopactualdate,stopactualtime);
    ttime = mkCalTime(stopactualdate,stopactualtime,stopActMs);
    printf("\nCalculate partial chain hash value until time(%d,%d)\n",ttime.tv_sec,ttime.tv_usec);


    while (p != NULL && np != tree->nil) {
        if (time_cmp(p->time, ttime) >= 0)
            break;
        printf("TOL:txn_time(%d,%d)\n",
                   p->time.tv_sec, p->time.tv_usec);

        printf("    start hash_value = ");
        print_hash(hash_value);

        printf("    txn_hash =");
        print_hash(p->hash_value);

        memcpy(txn_hash_data.prev_hash_value, hash_value, AUD_HASH_LEN);
        txn_hash_data.time = p->time;
        memcpy(txn_hash_data.hash_value, p->hash_value, AUD_HASH_LEN);
        if (__aud_hash(&txn_hash_data, sizeof(AUD_TXN_HASH_DATA), hash_value) != 0) {
            insErrEvent(dbc,"Error in call __aud_hash API!");
            fprintf(stderr,"Error in call __aud_hash API!");
            exit(1);
        }


        printf("    tail_hash=");
        print_hash(hash_value);
        np = TreeSuccessor(tree, np);

        if (tree->nil == np ) {
            break;
        }
        p = (np == NULL)? NULL: (VER_TOL_ENTRY *)(np->info);
    }


    // store hash_value
    // send hash value to surety to get NotarID
    /* Establish UDP */


    memset(&servaddr, 0, sizeof(servaddr));
    servaddr.sin_family = AF_INET;
    servaddr.sin_port = htons(port);

    serv_p = gethostbyname(server);
    bcopy(serv_p->h_addr, &servaddr.sin_addr, serv_p->h_length);     

    sockfd = socket(AF_INET, SOCK_DGRAM, 0);

    sendto(sockfd, hash_value, AUD_HASH_LEN, 0,
                (SA *)&servaddr, sizeof(servaddr));

    printf("Request sent: \n");
    print_hash(hash_value);

    n = recvfrom(sockfd, &rnid, sizeof(rnid), 0, NULL, NULL);
    printf("    N-id received:\n");
    print_hash(rnid.nid);

    if (chaintype == 'B') {
        // get the stored Nid in Chain table
        getNIDfromChain(dbc,onid.nid,eventID);
    }
    else if (chaintype == 'P') {
        A3DgetNIDfromChain(dbc,onid.nid,eventID,startActDate,startActMs,stopActDate,stopActMs);
    }

printf("Original Notarizer Nid:");
    print_hash(onid.nid);

    char curTamperID[IDLEN];

    // get current Tampering ID
    getTamperID(dbc,curTamperID);

    if (memcmp(onid.nid,rnid.nid,AUD_HASH_LEN) != 0) {
	printf(" A3D partial  Chain Check find corruption here!!!\n");
	insNotCheck(dbc,chainID,"F",curTamperID);
	return 0;
    }
    else {
	insNotCheck(dbc,chainID,"P",curTamperID);
	return 1;
    }

}



void A3DPartialChain(SQLHDBC dbc, char *server, in_port_t port) 
{
    int i,d;

    int sum,length;    

    char hash_value[AUD_HASH_LEN];
    NID rnid;
    
    int granule = getCurNotGranule(dbc);

printf("\ngetCurNotGranule:%d\n",granule);


printf(" need add more partial chains\n");

    d = 0;
    while (1) {

	sum = A3DgetPower(d);

  	if (granule % sum  == 0 && granule % (sum*2) != 0 ) {
	    break;
	}
        d++;
    }
printf("got integer d is %d\n",d);

    // add chain with length from 1,2,4,8,....,2tod
    if (d > 0 && A3DpowerOf2(granule)) {
	d--;
    }

printf("Final integer d is %d\n",d);

    //char prevactualdate[DATELEN],prevactualtime[DATELEN], prevactualms[MSLEN];
    char stopSchDate[TIMESTPLEN],stopActDate[TIMESTPLEN],stopactualms[MSLEN];
    char startSchDate[TIMESTPLEN],startActDate[TIMESTPLEN],startactualms[MSLEN];

    char maxPreNotID[IDLEN];
    char stopNotID[IDLEN];

    // given current stop Date
    getStop(dbc,stopSchDate,stopActDate,stopactualms,maxPreNotID);
printf("\nStop scheduled date:%s,stopActDate:%s,eventID:%s\n",stopSchDate,stopActDate,maxPreNotID);

    i = 0;
    while (i <= d) {
	//length = A3DgetPower(i);
printf("add the [%d] chain for length[%d]\n",i, length);

	getChainStart(dbc,i,maxPreNotID,startSchDate,startActDate,startactualms);
printf("\nStart scheduled date:%s,startActDate:%s\n",startSchDate,startActDate);

	rnid = A3DcalChainNID(dbc,startActDate,startactualms,stopActDate,stopactualms,server,port,hash_value);

//printf("This chain hashvalue:\n");
//print_hash(rnid.nid);

	A3DinsertChain(dbc,startActDate,startactualms,stopActDate,stopactualms,hash_value, rnid);
	i++;
    }
    
    // add the delayed chain

    getPreNotID(dbc,stopNotID, maxPreNotID);

    getChainStart(dbc,0,stopNotID,startSchDate,startActDate,startactualms);

getPreNotEvent(dbc, stopNotID,stopSchDate, stopActDate, stopactualms, maxPreNotID);

    rnid = A3DcalChainNID(dbc,startActDate,startactualms,stopActDate,stopactualms,server,port, hash_value);

    A3DinsertChain(dbc,startActDate,startactualms,stopActDate,stopactualms,hash_value, rnid);
   
printf("insert one delayed chain\n");
}



// insert a partial chain into Chain table
void A3DinsertChain(SQLHDBC dbc, char *startActDate, char *startactualms, char *stopActDate, char *stopactualms,char *hash_value, NID nid) 
{
    int i;

    SQLCHAR insChain[MAXINSLEN] = "insert into Chain (EventID,Color,StartDate,StartMilliseconds,Hashcode,NotarID,StopDate,StopMilliseconds) VALUES (";

    char tempstr[AUD_HASH_LEN];

    char curValEventID[IDLEN];

    getMaxValID(dbc,curValEventID);
    strcat(insChain,curValEventID);
    strcat(insChain,",'A3D_P','");

    strcat(insChain,startActDate);
    strcat(insChain,"',");
    strcat(insChain,startactualms);
    strcat(insChain,",'");

    // HashCode
    for (i=0; i<AUD_HASH_LEN; i++)
    {
        sprintf(tempstr,"%02X", 0xff & hash_value[i]);
        strcat(insChain,tempstr);
    }
    strcat(insChain,"','");

    //transfer NID into hashvalue(char)
    for (i=0; i<AUD_HASH_LEN; i++)
    {
        sprintf(tempstr,"%02X", 0xff & nid.nid[i]);
        strcat(insChain,tempstr);
    }
    //printf("*********tempstr:%s\n",tempstr);
    strcat(insChain,"','");

    strcat(insChain,stopActDate);
    strcat(insChain,"',");
    strcat(insChain,stopactualms);

    strcat(insChain,")");

printf("A3D insert partial Chain:[%s]\n",insChain);
    // insert tuple into Chain table
    exeSqlQuery(dbc,insChain);

printf("Insert one A3d partial chain for validator\n");


}

//
// calculate hash value given time range(start,stop) 
// insert into Chain table for this chain value
//
NID A3DcalChainNID(SQLHDBC dbc, char *startActDate, char *startActMs, char *stopActDate, char *stopActMs, char *server, in_port_t port, char *hash_value)
{
    VER_TOL_ENTRY *p;
    AUD_TXN_HASH_DATA txn_hash_data;
    rb_red_blk_node *np;


    struct timeval stime,ttime;
//    struct timeval start_time;

    char stopactualdate[DATELEN],stopactualtime[DATELEN];
    char startactualdate[DATELEN],startactualtime[DATELEN];

    NID rnid;

    int sockfd;
    struct hostent *serv_p;
    SAI servaddr;
    int n;

    printf("Begin calculate partial chain hashing.\n");

    np = RBMin(tree);
    p = (np == NULL)? NULL: (VER_TOL_ENTRY *)(np->info);
    memset(hash_value, 0, AUD_HASH_LEN);

    // set the start time for this partial chain 
    getDate(startActDate,startactualdate,startactualtime);
    stime = mkCalTime(startactualdate,startactualtime,startActMs);
    printf("\nCalculate partial chain hash value start time(%d,%d), %s\n",stime.tv_sec,stime.tv_usec,startActDate);

    // Rechain the txn's in TOL till the tail time "ttime"
    // locate the start txn

    while (p != NULL) {
        if (time_cmp(p->time, stime) >= 0)
            break;

        printf("TOL:jump txn_time(%d,%d)\n",
                   p->time.tv_sec, p->time.tv_usec);

        printf("    jump hash_value = ");
        print_hash(hash_value);

        printf("    jump txn_hash =");
        print_hash(p->hash_value);

        np = TreeSuccessor(tree, np);

        if (tree->nil == np ) {
            break;
        }
        p = (np == NULL)? NULL: (VER_TOL_ENTRY *)(np->info);
    }

    // set the stop time for this partial chain 
    getDate(stopActDate,stopactualdate,stopactualtime);
    ttime = mkCalTime(stopactualdate,stopactualtime,stopActMs);
    printf("\nCalculate partial chain hash value until time(%d,%d) %s\n",ttime.tv_sec,ttime.tv_usec,stopActDate);


    while (p != NULL && np != tree->nil) {
        if (time_cmp(p->time, ttime) >= 0)
            break;
        printf("TOL:txn_time(%d,%d)\n",
                   p->time.tv_sec, p->time.tv_usec);

        printf("    start hash_value = ");
        print_hash(hash_value);

        printf("    txn_hash =");
        print_hash(p->hash_value);

        memcpy(txn_hash_data.prev_hash_value, hash_value, AUD_HASH_LEN);
        txn_hash_data.time = p->time;
        memcpy(txn_hash_data.hash_value, p->hash_value, AUD_HASH_LEN);
        if (__aud_hash(&txn_hash_data, sizeof(AUD_TXN_HASH_DATA), hash_value) != 0) {
            insErrEvent(dbc,"Error in call __aud_hash API!");
            fprintf(stderr,"Error in call __aud_hash API!");
            exit(1);
        }


        printf("    tail_hash=");
        print_hash(hash_value);

        np = TreeSuccessor(tree, np);

        if (tree->nil == np ) {
            break;
        }
        p = (np == NULL)? NULL: (VER_TOL_ENTRY *)(np->info);
    }


    // store hash_value
    // send hash value to surety to get NotarID
    /* Establish UDP */

    memset(&servaddr, 0, sizeof(servaddr));
    servaddr.sin_family = AF_INET;
    servaddr.sin_port = htons(port);

    serv_p = gethostbyname(server);
    bcopy(serv_p->h_addr, &servaddr.sin_addr, serv_p->h_length);
    sockfd = socket(AF_INET, SOCK_DGRAM, 0);

    sendto(sockfd, hash_value, AUD_HASH_LEN, 0,
                (SA *)&servaddr, sizeof(servaddr));

    printf("Request sent: \n");
    print_hash(hash_value);

    n = recvfrom(sockfd, &rnid, sizeof(rnid), 0, NULL, NULL);
    printf("    N-id received:\n");
    print_hash(rnid.nid);

    return rnid;

}


//
// get start Scheduled Date & Actual Date& actual ms, given stop Scheduled Date and chain length
// length: the number of Notarization Interval
//
void getChainStart(SQLHDBC dbc, int length, char *stopNotID, char *startSchDate,char *startActDate, char *startactualms)
{
    char prevEventID[IDLEN],prevSchDate[TIMESTPLEN],prevActDate[TIMESTPLEN],prevactualms[MSLEN],curNotID[IDLEN];

    int chainlen;

    bzero(curNotID,IDLEN);
    strcpy(curNotID,stopNotID);

    chainlen = A3DgetPower(length);

    if (chainlen <= 0){
    	insErrEvent(dbc,"Chain length less than or equals to zero");
	return;
    }

    while (chainlen-- > 0) {
	getPreNotEvent(dbc, prevEventID,prevSchDate, prevActDate, prevactualms, curNotID);

        bzero(curNotID,IDLEN);
	strcpy(curNotID,prevEventID);

    }

    bzero(startSchDate,TIMESTPLEN);
    bzero(startActDate,TIMESTPLEN);
    bzero(startactualms,MSLEN);

    strcpy(startSchDate,prevSchDate);
    strcpy(startActDate,prevActDate);
    strcpy(startactualms,prevactualms);
}


void A3DgetNIDfromChain(SQLHDBC dbc,char *nid_value, char *EventID,char *startActDate, char *startActMs, char *stopActDate, char *stopActMs)
{
    SQLHSTMT stmt;
    SQLRETURN ret; /* ODBC API return status */
    SQLSMALLINT columns; /* number of columns in result-set */
    int row = 0;
    SQLINTEGER indicator;
    char buf[512];
    SQLUSMALLINT i=1;
    SQLCHAR getNID[SQLQUERY] = "select NotarID from Chain where Color='A3D_P' AND EventID=";
    int FindEvent = 0;

    //int oldstrlen = strlen(getNID);
    //strncat(getNID,hash_value,AUD_HASH_LEN);
    //getNID[oldstrlen+AUD_HASH_LEN+1] = '\0';

    strcat(getNID,EventID);
    strcat(getNID, " and StartDate='");
    strcat(getNID, startActDate);
    strcat(getNID, "' and StartMilliseconds=");
    strcat(getNID, startActMs);
    strcat(getNID, " and StopDate='");
    strcat(getNID, stopActDate);
    strcat(getNID, "' and StopMilliseconds=");
    strcat(getNID, stopActMs);

    

    /* Allocate a statement handle */
    SQLAllocHandle(SQL_HANDLE_STMT, dbc, &stmt);

    //get Configuration Column names
    ret = SQLExecDirect(stmt,getNID,SQL_NTS);
    printf("A3DgetNIDfromChain:%s\n",getNID);

    bzero(nid_value,AUD_HASH_LEN);
    if (ret == SQL_SUCCESS) {
        while (1) {
            ret = SQLFetch(stmt);
            if (ret == SQL_ERROR || ret == SQL_SUCCESS_WITH_INFO) {
                show_a3d_error();
            }

            if (ret == SQL_SUCCESS || ret == SQL_SUCCESS_WITH_INFO) {
                FindEvent = 1;

                SQLUSMALLINT i = 1;

                /* How many columns are there */
                SQLNumResultCols(stmt, &columns);

                /* Loop through the columns */
                for (i = 1; i <= columns; i++) {

                    /* retrieve column data as a string */
                    if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, sizeof(buf), &indicator))) {
                            str_to_value(buf,2*AUD_HASH_LEN,nid_value,AUD_HASH_LEN);
//sprintf(nid_value,"%s",nid_value);
//                      strcpy(nid_value,buf);
                    }
                }
            } else {
                break;
            }
        }
   }

   if (!FindEvent) {
        insErrEvent(dbc,"Can't find NID for this Event\n");
        fprintf(stderr,"Can't find NID for this Event\n");
        exit(1);
   }

}



// get the stop Validation EventID according to the corresponding notarization EventID
void A3DgetValID(SQLHDBC dbc, char *stopValID, char *stopNotID)
{
    SQLHSTMT stmt;

    SQLRETURN sqlret; /* ODBC API return status */

    SQLINTEGER indicator;

    SQLSMALLINT columns; /* number of columns in result-set */

    char notSchDate[TIMESTPLEN];
    bzero(notSchDate,TIMESTPLEN);

    char buf[MAXEVENTBUF];

    bzero(stopValID,IDLEN);

    int FindEvent = 0;

    SQLCHAR getSchDate[SQLQUERY] = "select ScheduledDate from Event where EventID=";

    strcat(getSchDate,stopNotID);

printf("A3DgetValID,getSchDate[%s]\n",getSchDate);

 /* Allocate a statement handle */
    SQLAllocHandle(SQL_HANDLE_STMT, dbc, &stmt);

    /* read from Configuration table*/
    sqlret = SQLExecDirect(stmt,getSchDate,SQL_NTS);

    if (sqlret == SQL_SUCCESS) {
        while (1) {
            sqlret = SQLFetch(stmt);
            if (sqlret == SQL_ERROR || sqlret == SQL_SUCCESS_WITH_INFO) {
                show_a3d_error();
            }

            if (sqlret == SQL_SUCCESS || sqlret == SQL_SUCCESS_WITH_INFO) {

                FindEvent = 1;

                SQLUSMALLINT i;

                /* How many columns are there */
                SQLNumResultCols(stmt, &columns);

                /* Loop through the columns */
                for (i = 1; i <= columns; i++) {

                    /* retrieve column data as a string */
                    bzero(buf,MAXEVENTBUF);
                    if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, MAXEVENTBUF, &indicator))) {
                        strcpy(notSchDate,buf);
                    }
                }
            } else {
                break;
            }
        }
    }

    if (!FindEvent ) {
        insErrEvent(dbc,"Can't find this Not EventID");
        return;
    }


    SQLCHAR getValID[SQLQUERY] = "Select min(EventID) from Event where Kind='V' AND Path='";

    strcat(getValID,ConfigTable.Dbpath);
    strcat(getValID, "' and Name='");
    strcat(getValID,ConfigTable.Dbname);
    strcat(getValID, "' and EventID>");
    strcat(getValID, stopNotID);
    strcat(getValID, " and ScheduledDate>='");
    strcat(getValID, notSchDate);
    strcat(getValID, "'");



 /* Allocate a statement handle */
    SQLAllocHandle(SQL_HANDLE_STMT, dbc, &stmt);

    /* read from Configuration table*/
printf("A3DgetValID:[%s]\n",getValID);
    sqlret = SQLExecDirect(stmt,getValID,SQL_NTS);

    FindEvent = 0;

    if (sqlret == SQL_SUCCESS) {
        while (1) {
            sqlret = SQLFetch(stmt);
            if (sqlret == SQL_ERROR || sqlret == SQL_SUCCESS_WITH_INFO) {
                show_a3d_error();
            }

            if (sqlret == SQL_SUCCESS || sqlret == SQL_SUCCESS_WITH_INFO) {

                FindEvent = 1;

                SQLUSMALLINT i;

                /* How many columns are there */
                SQLNumResultCols(stmt, &columns);


                /* Loop through the columns */
                for (i = 1; i <= columns; i++) {

                    /* retrieve column data as a string */
                    bzero(buf,MAXEVENTBUF);
                    if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, MAXEVENTBUF, &indicator))) {
                        strcpy(stopValID,buf);
                    }
                }
            } else {
                break;
            }
        }
    }

    if (!FindEvent) {
        insErrEvent(dbc,"Can't find a Val Event for Not EventID");
        return;
    }

}




int A3DpowerOf2(int granule)
{
    int i;

    while (1) {
	if (granule == 0 || granule == 1) return 1;

    	i = granule % 2;
    	if (i == 1) {
	    return 0;
    	}
	granule /= 2;
    }

}

// get 2 raised to the power of exp
int A3DgetPower(int exp)
{
    int i = 0;
    int sum = 1;

    while (i < exp) {
	sum = sum * 2;
 	i++;
    }

//printf("A3DgetPower(%d) is [%d]\n",exp,sum);
    return sum;
}
