#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <netdb.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <sys/times.h>


/* TT support */
#include "db.h"
#include <alg.h>

/*ODBC support*/
#include <sql.h>
#include <sqlext.h>

#include "common.h"
#include "sha1.h"
#include "memchunk.h"

typedef struct sockaddr SA; 

DB_ENV *dbenv;
DB *db;

//#define ATCOMLEN 512
#define TIMELEN 5

#define MAXMIN 60	
#define MAXHOUR 24
#define MAXDAYS_1 30
#define MAXDAYS_2 31
#define MAXMONTH 12

#define VALAPPNAME "validator"
#define ATRETBUF 256

#define FILENAMELEN 100

typedef struct sockaddr_in SAI; 

void show_my_error()
{
    fprintf(stderr, "Error in alg.c!\n");
    exit(1);
}


void Notarize(SQLHDBC dbc, VerificationParameter *ver_param) {
//    int sockfd;
//    in_port_t port;
//    struct hostent *serv_p;
//    SAI servaddr;
    int cnt,i;
    struct timeval ttime,old_ttime;
    char hash_value[AUD_HASH_LEN];
    DBT key, data;
    int n, ret;
    DB_TXN *tid;

//    NID nid;

    //SQLCHAR insEvent[MAXINSLEN] = "insert into Event (ScheduledDate,ActualDate,ActualMilliseconds,Path,Name,Kind,atID) VALUES ('";

    SQLCHAR updateEvent[MAXINSLEN] = "update Event set ActualDate='";

    SQLCHAR insChain[MAXINSLEN] = "insert into Chain (EventID,Color,StartDate,StartMilliseconds,Hashcode,NotarID,StopDate,StopMilliseconds) VALUES (";

    char tempstr[AUD_HASH_LEN];


    //start a socket. replaced by Surety ****************************
//    printf("notarization server:%s\n", ver_param->server_name);
//
//    port = 11111; // for test only

//    printf("Audit Notarization Request Utility Starts...\n");
//    memset(&servaddr, 0 , sizeof(servaddr));
//    servaddr.sin_family = AF_INET;
//    servaddr.sin_port = htons(port);

/* Modified by Huilong */
//    serv_p = gethostbyname(ver_param->server_name);
//    bcopy(serv_p->h_addr, &servaddr.sin_addr, serv_p->h_length);
//    inet_pton(AF_INET,server, &servaddr.sin_addr);
/* Huilong */

//    sockfd = socket(AF_INET, SOCK_DGRAM, 0);

    //****************************************************************

    cnt = 0;
    memset(&old_ttime, 0, sizeof(old_ttime));

    // get the event_date and event_time for the current Notarization Event
    char prevschdate[DATELEN],prevschtime[DATELEN];
    char curschdate[DATELEN],curschtime[DATELEN];


    //Initialize date and time buffer
//    bzero(prevschdate,DATELEN);
//    bzero(prevschtime,DATELEN);
    bzero(curschdate,DATELEN);
    bzero(curschtime,DATELEN);
 
    char prevSchDate[TIMESTPLEN],prevActDate[TIMESTPLEN],prevActMs[MSLEN];
    char curSchDate[TIMESTPLEN],curActDate[TIMESTPLEN],curActMs[MSLEN];
    char curNotEventID[IDLEN];

    // get current running EventID in the Event table
    getCurNotEvent(dbc,curNotEventID,curSchDate);

//    printf("previous Scheduled Date:[%s]\n",prevSchDate);
    printf("current Scheduled Date:[%s]\n",curSchDate);

    // scheduledate
    //strcat(insEvent,curSchDate);
    //strcat(insEvent,"','");


    //get current CPU time as the NotEvent time
    struct timeval current_t;

    // Set the ActualDate,ActualMilliseconds
//    gettimeofday(&current_t,NULL);    

    //actualdate
    /*update in the Event table*/

    // talk to surety
/* Huilong for hard-coded path on 5/3/2007 */
    char pathname[256];
    pathname[0]='\0';
    sprintf(pathname, "%s", ConfigTable.Dbpath);
    //sprintf(pathname, "/cs/timecenter/tau/audit/auditutilities_mz_6_6_2007/%s", ConfigTable.Dbpath);

printf("Before get time and hash!\n");
    __aud_get_time_hash(/*ConfigTable.Dbpath*/pathname, ConfigTable.Dbname, hash_value, &ttime, &current_t);
printf("After get time and hash!\n");

/* Huilong for debug synchronization */
   printf("!!!!! Txn time (%d, %d), Notarization time(%d, %d) !!!!!!!!!\n", ttime.tv_sec, ttime.tv_usec,current_t.tv_sec, current_t.tv_usec); 
/* End Huilong */

    strftime(curActDate, TIMESTPLEN, "%Y-%m-%d %X",
             localtime(&(current_t.tv_sec)));
    strcat(updateEvent,curActDate);
    strcat(updateEvent,"',ActualMilliseconds=");

    sprintf(curActMs,"%d",current_t.tv_usec);
    strcat(updateEvent,curActMs);
    strcat(updateEvent," where EventID=");
    strcat(updateEvent,curNotEventID);

printf("\nUpdate Not Event:[%s]\n",updateEvent);
    exeSqlQuery(dbc,updateEvent);
   printf("  Notarize-Event updated in the Event table.\n");
/* Huilong */

    memcpy(&old_ttime, &ttime, sizeof(ttime));

	//hash the hash_value and store it as nid for the future purpose of forensic analysis
	sha1Param param;

	/* Do the hashing */
	if (sha1Reset(&param))
	    exit(1);
	if (sha1Update(&param, hash_value, AUD_HASH_LEN))
	    exit(1);
	if (sha1Digest(&param, ver_param->nid_output.nid))
	    exit(1);
	gettimeofday(&(ver_param->nid_output.ntime), NULL);

    ver_param->dbc = dbc;
    ver_param->notarization_id = curNotEventID;
    memcpy(&(ver_param->ttime), &ttime, sizeof(ttime));
    ver_param->hash_value = (char*) malloc (AUD_HASH_LEN);
    memcpy(ver_param->hash_value, hash_value, AUD_HASH_LEN);
    CommunicateWithDNS(ver_param);
    free(ver_param->hash_value);

    //replaced by Surety *********************************************
/*
    char notarizedFileName[FILENAMELEN];
    sprintf(notarizedFileName, "%s/abc.txt", PATH);
    char notRecFileName[FILENAMELEN];
    sprintf(notRecFileName, "%s/abc.snr", PATH);
    char valResultFileName[FILENAMELEN];
    sprintf(valResultFileName, "%s/result.txt", PATH);
    FILE *notarizedFile;
    FILE *notRecFile;
    FILE *valResultFile; // declare a FILE pointer  

    char c;

    char suretyNotarizeCommand[ATCOMLEN];
    sprintf(suretyNotarizeCommand,
            "%s/testnc -n -s test.surety.com -u \
            Arizona-Test1 -p glyutnsVUU -d ",
            PATH);
    char suretyValidateCommand[ATCOMLEN];
    sprintf(suretyValidateCommand,
            "%s/testnc -v -s test.surety.com -u \
            Arizona-Test1 -p glyutnsVUU -d ",
            PATH);

    strcat(suretyNotarizeCommand,notarizedFileName);
    strcat(suretyNotarizeCommand," -r ");
    strcat(suretyNotarizeCommand,notRecFileName);

    strcat(suretyValidateCommand,notarizedFileName);
    strcat(suretyValidateCommand," -r ");
    strcat(suretyValidateCommand,notRecFileName);
    strcat(suretyValidateCommand," > ");
    strcat(suretyValidateCommand,valResultFileName);

    char rmNotRecCommand[ATCOMLEN]="rm -f ";
    strcat(rmNotRecCommand,notRecFileName);

    char validation_result;

    //write hash_value to "abc.txt"
    notarizedFile=fopen(notarizedFileName,"w");
    for (i=0; i<AUD_HASH_LEN; i++)
    {
    	fprintf(notarizedFile,"%02X",0xff & hash_value[i]); 
    }


    if (fclose(notarizedFile)) {
        fprintf(stderr, "err source: dd\n");
 	show_my_error();
    }


    //before each notarize, delete the rec file 
    if (system(rmNotRecCommand) == -1) {
        // error when run Notarizer from shell
        fprintf(stderr,"Can't run notarizer");
        exit(1);
    }

    printf("SURETY IS COMMING! Notarized Hash_value is %s\n",hash_value);

    //now can set the next execution of Notarizer
    if (system(suretyNotarizeCommand) == -1) {
        // error when run Notarizer from shell
        //insErrEvent(dbc,"Can't run notarizer");  TODO: needs to include dbc
        fprintf(stderr,"Can't run notarizer");
        exit(1);
    }
*/

   // Insert this Black chain into Chain Table
    //sprintf(tempstr,"%d,'black','",getMaxNotID(dbc));
    //strcat(insChain,tempstr);
    strcat(insChain,curNotEventID);
    strcat(insChain,",'black','");

    char prevNotID[IDLEN];

    // get previous Notarization Event:StartDate,StartMilliseconds 
    getPreNotEvent(dbc,prevNotID,prevSchDate,prevActDate,prevActMs,curNotEventID);
printf("\nprevActDate[%s],prevActMs[%s]\n",prevActDate,prevActMs);

    char startTime[TIMESTPLEN];
    getTimestp(startTime,ConfigTable.StartDate,ConfigTable.StartTime);

    strcat(insChain,startTime);
    strcat(insChain,"',");
    strcat(insChain,"0");
    strcat(insChain,",'");

    // HashCode
    for (i=0; i<AUD_HASH_LEN; i++)
    {
        sprintf(tempstr,"%02X", 0xff & hash_value[i]);
        strcat(insChain,tempstr);
    }
    strcat(insChain,"','");

    //transfer NID into hashvalue(char)
    for (i=0; i<AUD_HASH_LEN; i++)
    {
        sprintf(tempstr,"%02X", 0xff & (ver_param->nid_output.nid[i]));
        strcat(insChain,tempstr);
    }
    //printf("*********tempstr:%s\n",tempstr);
    strcat(insChain,"','");

    strcat(insChain,curActDate);
    strcat(insChain,"',");
    strcat(insChain,curActMs);

    strcat(insChain,")");

printf("insert Chain:[%s]\n",insChain);
    // insert tuple into Chain table
    exeSqlQuery(dbc,insChain);

printf("Insert one black chain for notarizer\n");

exit_not:
    // set next running of Notarizer
    getDate(curSchDate,curschdate,curschtime);

    ScheduleNext(curschdate, curschtime, ver_param, dbc);

    // check whether or not to start the Validator
    char preValSchDate[TIMESTPLEN],preValActDate[TIMESTPLEN],preValActMs[MSLEN];
    int testRunVal = 0;

    if (!getMaxValEvent(dbc,preValSchDate,preValActDate,preValActMs)) {

	// haven't run Valiator yet
        getTimestp(preValSchDate,ConfigTable.StartDate,ConfigTable.StartTime);

	// get count for ran 'N' event
        if (getNotEventCount(dbc) - 1 == ConfigTable.VFactor) {
	    testRunVal = 1;
	}
    }else {
	testRunVal = 1;
    }

    char lastvaldate[DATELEN],lastvaltime[DATELEN];


    // check if the scheduled time is reasonable

printf("previous validator time:%s\n",preValSchDate);
printf("current time:%s\n",curSchDate);

    if (strcmp(curSchDate,preValSchDate) < 0) {
        insErrEvent(dbc,"Validator scheduled date is earlier than the current time");
        fprintf(stderr, "err source: cc\n");
	show_my_error();
    }    

    // get time interval since last validator running
    getDate(preValSchDate,lastvaldate,lastvaltime);

    unsigned long timeIntSec = getTimeInt(curschdate,curschtime,lastvaldate,lastvaltime);

    // get scheduled validation interval
    unsigned long ValIntSec = (ConfigTable.NotIntDays * 24*60*60 +
                ConfigTable.NotIntHrs *60*60 + ConfigTable.NotIntMins*60) * ConfigTable.VFactor;


printf("Current Not date:[%s],time:[%s]\n",curschdate,curschtime);
printf("Previous Val date:[%s],time:[%s]\n",lastvaldate,lastvaltime);
printf("timeIntSec:%d\n",timeIntSec);
printf("ValIntSec:%d\n",ValIntSec);

    //if (timeIntSec >= ValIntSec && ((ValFstRun && ConfigTable.VFactor == 1) || !ValFstRun)) {

fprintf(stderr, "******* check conditions: %d <> %d ?\n", timeIntSec, ValIntSec);
    if (timeIntSec >= ValIntSec && testRunVal) {
  	// call validator to run

/*
        char valCommand[ATCOMLEN];
	bzero(valCommand,ATCOMLEN);

        strcat(valCommand,"/cs/timecenter/tau/audit/auditutilities/");
	strcat(valCommand,VALAPPNAME);
        strcat(valCommand," ");
    	strcat(valCommand,ConfigTable.Dbpath);
        strcat(valCommand," ");
	strcat(valCommand,ConfigTable.Dbname);
        strcat(valCommand," ");
	strcat(valCommand,server);

    	// start running of Validator
printf("RUN Validator:[%s]\n",valCommand);
    	if (system(valCommand) == -1) {
            // error when run Validator from shell
            insErrEvent(dbc,"Can't run validator");
            fprintf(stderr,"Can't run validator");
            exit(1);
        }
*/
	// below at command to triger validator for test only
	char valJobFile[FILENAMELEN]="atvaljob";
        FILE *valJob;
        char valAtCommand[ATCOMLEN]="at -f ";
        char delValJob[ATCOMLEN]="rm -f ";

	char createID[IDLEN];

    	getCreateID(dbc,createID);

	strcat(valJobFile,createID);

	strcat(delValJob,valJobFile);

        // create the at command file for scheduling the Notarizer
        valJob = fopen(valJobFile,"w+");
        if (ver_param->method == LOCAL_VERIFICATION) {
          fprintf(valJob, "%s/validator %s %s %s \n",
                  ver_param->binary_dir,
                  ConfigTable.Dbpath, ConfigTable.Dbname,
                  ver_param->server_name);
        } else if (ver_param->method == SURETY_VERIFICATION) {
          fprintf(valJob, "%s/validator %s %s %s %s \n",
                  ver_param->binary_dir,
                  ConfigTable.Dbpath, ConfigTable.Dbname,
                  ver_param->surety_user_name, ver_param->surety_password);
        }

        if (fclose(valJob)) {
            fprintf(stderr, "error source b\n");
            show_my_error();
        }

        strcat(valAtCommand,valJobFile);
        strcat(valAtCommand," now");
        // start running of Validator
printf("RUN Validator by at command:[%s]\n",valAtCommand);
        system(valAtCommand);
//end test part

	// delete val Job File
//        if (system(delValJob) == -1) {
//            insErrEvent(dbc,"Can't delete valJobFile");
//        }

    }
    return; 
}


// get time interval by seconds from lastdate/lasttime to date/time
unsigned long getTimeInt(char *date, char *time, char *lastdate, char *lasttime)
{

    int i=0,j=0;
    int hour1,min1,year1,month1,day1;
    int hour2,min2,year2,month2,day2;
    char hourchar1[TIMELEN],minchar1[TIMELEN],secchar1[TIMELEN],yearchar1[TIMELEN],monthchar1[TIMELEN],daychar1[TIMELEN];
    char hourchar2[TIMELEN],minchar2[TIMELEN],secchar2[TIMELEN],yearchar2[TIMELEN],monthchar2[TIMELEN],daychar2[TIMELEN];
    enum {JAN=1,FEB,MAR,APR,MAY,JUN,JUL,AUG,SEP,OCT,NOV,DEC};


    bzero(hourchar1,TIMELEN);
    bzero(minchar1,TIMELEN);
    bzero(secchar1,TIMELEN);
    bzero(yearchar1,TIMELEN);
    bzero(monthchar1,TIMELEN);
    bzero(daychar1,TIMELEN);

    bzero(hourchar2,TIMELEN);
    bzero(minchar2,TIMELEN);
    bzero(secchar2,TIMELEN);
    bzero(yearchar2,TIMELEN);
    bzero(monthchar2,TIMELEN);
    bzero(daychar2,TIMELEN);

    //get current event time(hour,minute)
    while(time[i]!=':' && i<strlen(time))
    {
        hourchar1[j]=time[i];
        j++;
        i++;
    }
    hour1 = atoi(hourchar1);

//    printf("hour:[%d]\n",hour);

    j=0;
    i++;
    while(time[i]!=':' && i< strlen(time))
    {
        minchar1[j]=time[i];
        i++;
        j++;
    }
    min1 = atoi(minchar1);
//    printf("mins:[%d]\n",min);

    j=0;
    i++;
    while(time[i]!='\'' && i< strlen(time))
    {
        secchar1[j]=time[i];
        i++;
        j++;
    }

    //get current event date(year,month,day)
    i=0;
    j=0;
    while(date[i]!='-' && i<strlen(date))
    {
        yearchar1[j]=date[i];
        j++;
        i++;
    }

    year1 = atoi(yearchar1);
//    printf("year:[%d]\n",year);

    j=0;
    i++;
    while(date[i]!='-' && i< strlen(date))
    {
        monthchar1[j]=date[i];
        i++;
        j++;
    }
    month1 = atoi(monthchar1);
//    printf("month:[%d]\n",month);

    j=0;
    i++;

    while(date[i]!='\'' && i< strlen(date))
    {
        daychar1[j]=date[i];
        i++;
        j++;
    }
    day1 = atoi(daychar1);

    //get current event time(hour,minute)
    i=0;
    j=0;
    while(lasttime[i]!=':' && i<strlen(lasttime))
    {
        hourchar2[j]=lasttime[i];
        j++;
        i++;
    }
    hour2 = atoi(hourchar2);

//    printf("hour:[%d]\n",hour);

    j=0;
    i++;
    while(lasttime[i]!=':' && i< strlen(lasttime))
    {
        minchar2[j]=lasttime[i];
        i++;
        j++;
    }
    min2 = atoi(minchar2);
//    printf("mins:[%d]\n",min);

    j=0;
    i++;
    while(lasttime[i]!='\'' && i< strlen(lasttime))
    {
        secchar2[j]=lasttime[i];
        i++;
        j++;
    }

    //get current event date(year,month,day)
    i=0;
    j=0;
    while(lastdate[i]!='-' && i<strlen(lastdate))
    {
        yearchar2[j]=lastdate[i];
        j++;
        i++;
    }

    year2 = atoi(yearchar2);
//    printf("year:[%d]\n",year);

    j=0;
    i++;
    while(lastdate[i]!='-' && i< strlen(lastdate))
    {
        monthchar2[j]=lastdate[i];
        i++;
        j++;
    }
    month2 = atoi(monthchar2);
//    printf("month:[%d]\n",month);

    j=0;
    i++;

    while(lastdate[i]!='\'' && i< strlen(lastdate))
    {
        daychar2[j]=lastdate[i];
        i++;
        j++;
    }
    day2 = atoi(daychar2);

    int totaldays1 = (year1-1) * 365 + (year1 -1) / 4;
    int totaldays2 = (year2-1) * 365 + (year2 - 1) / 4;

        switch (month1)
        {
            case JAN:
                totaldays1 += day1 - 1;
                break;

            case FEB:
		totaldays1 += MAXDAYS_2 + day1 -1 ;
		break;

	    case MAR:
                totaldays1 = MAXDAYS_2 + 28 + day1 - 1;
                break;

            case APR:
                totaldays1 = MAXDAYS_2*2 + 28 + day1 - 1;
                break;

            case MAY:
                totaldays1 = MAXDAYS_2*2 + 28 + MAXDAYS_1 + day1 - 1;
                break;

            case JUN:
                totaldays1 = MAXDAYS_2*3 + 28 + MAXDAYS_1 + day1 - 1;
                break;

            case JUL:
                totaldays1 = MAXDAYS_2*3 + 28 + MAXDAYS_1*2 + day1 - 1;
                break;

            case AUG:
                totaldays1 = MAXDAYS_2*4 + 28 + MAXDAYS_1*2 + day1 - 1;
                break;

            case SEP:
                totaldays1 = MAXDAYS_2*5 + 28 + MAXDAYS_1*2 + day1 - 1;
                break;

            case OCT:
                totaldays1 = MAXDAYS_2*5 + 28 + MAXDAYS_1*3 + day1 - 1;
                break;

            case NOV:
                totaldays1 = MAXDAYS_2*6 + 28 + MAXDAYS_1*3 + day1 - 1;
                break;

            case DEC:
                totaldays1 = MAXDAYS_2*6 + 28 + MAXDAYS_1*4 + day1 - 1;
        }

    if (year1 % 4 == 0 && month1 > FEB) {
	totaldays1++;
    }


        switch (month2)
        {
            case JAN:
                totaldays2 += day2 - 1;
                break;

            case FEB:
                totaldays2 += MAXDAYS_2 + day2 -1 ;
                break;

            case MAR:
                totaldays2 = MAXDAYS_2 + 28 + day2 - 1;
                break;

            case APR:
                totaldays2 = MAXDAYS_2*2 + 28 + day2 - 1;
                break;

            case MAY:
                totaldays2 = MAXDAYS_2*2 + 28 + MAXDAYS_1 + day2 - 1;
                break;

            case JUN:
                totaldays2 = MAXDAYS_2*3 + 28 + MAXDAYS_1 + day2 - 1;
                break;

            case JUL:
                totaldays2 = MAXDAYS_2*3 + 28 + MAXDAYS_1*2 + day2 - 1;
                break;

            case AUG:
                totaldays2 = MAXDAYS_2*4 + 28 + MAXDAYS_1*2 + day2 - 1;
                break;

            case SEP:
                totaldays2 = MAXDAYS_2*5 + 28 + MAXDAYS_1*2 + day2 - 1;
                break;

            case OCT:
                totaldays2 = MAXDAYS_2*5 + 28 + MAXDAYS_1*3 + day2 - 1;
                break;

            case NOV:
                totaldays2 = MAXDAYS_2*6 + 28 + MAXDAYS_1*3 + day2 - 1;
                break;

            case DEC:
                totaldays2 = MAXDAYS_2*6 + 28 + MAXDAYS_1*4 + day2 - 1;
        }

    if (year2 % 4 == 0 && month2 > FEB) {
	totaldays2++;
    }

    return (totaldays1 - totaldays2)*24*60*60 + (hour1*60*60+min1*60) - (hour2*60*60+min2*60);

 


}





void get_next_date(char *curdate,char *curtime,char *nextdate, char *nexttime)
{
    int i=0,j=0;
    int hour,min,year,month,day;
    char hourchar[TIMELEN],minchar[TIMELEN],secchar[TIMELEN],yearchar[TIMELEN],monthchar[TIMELEN],daychar[TIMELEN];
    enum {JAN=1,FEB,MAR,APR,MAY,JUN,JUL,AUG,SEP,OCT,NOV,DEC};

    bzero(hourchar,TIMELEN);
    bzero(minchar,TIMELEN);
    bzero(secchar,TIMELEN);
    bzero(yearchar,TIMELEN);
    bzero(monthchar,TIMELEN);
    bzero(daychar,TIMELEN);

    bzero(nextdate,DATELEN);
    bzero(nexttime,DATELEN);

printf("get_next_date:curdate[%s],curtime[%s]\n",curdate,curtime);

    //get current event time(hour,minute)
    while(curtime[i]!=':' && i<strlen(curtime))
    {
    	hourchar[j]=curtime[i];
        j++;
	i++;
    }

    hour = atoi(hourchar);
    //printf("hour:[%d]\n",hour);

    j=0;
    i++;
    while(curtime[i]!=':' && i< strlen(curtime))
    {
    	minchar[j]=curtime[i];
	i++;
        j++;
    }
    min = atoi(minchar);
    //printf("mins:[%d]\n",min);

    j=0;
    i++;
    bzero(secchar,TIMELEN);
    while(curtime[i]!='\'' && i< strlen(curtime))
    {
    	secchar[j]=curtime[i];
	i++;
        j++;
    }

    //get current event date(year,month,day)
    i=0;
    j=0;
    while(curdate[i]!='-' && i<strlen(curdate))
    {
        yearchar[j]=curdate[i];
        j++;
        i++;
    }

    year = atoi(yearchar);
    printf("year:[%d]\n",year);

    j=0;
    i++;
    while(curdate[i]!='-' && i< strlen(curdate))
    {
        monthchar[j]=curdate[i];
        i++;
        j++;
    }
    month = atoi(monthchar);
    //printf("month:[%d]\n",month);

    j=0;
    i++;

    while(curdate[i]!='\'' && i< strlen(curdate))
    {
        daychar[j]=curdate[i];
        i++;
        j++;
    }
    day = atoi(daychar);
//    printf("day:[%d]\n",day);

    //calculate next Notarizer execute time

    min += ConfigTable.NotIntMins;
    if (min >= MAXMIN) {
	min -= MAXMIN;
	hour++;
    }

    hour += ConfigTable.NotIntHrs;
    if (hour >= MAXHOUR) {
	hour -= MAXHOUR;
	day++;
    }

    day += ConfigTable.NotIntDays;
    switch (month) 
    {
	case JAN:
	case MAR:
	case MAY:
	case JUL:
	case AUG:
	case OCT:
	case DEC:
	    if (day > MAXDAYS_2) {
		day -= MAXDAYS_2;
		month++;
	    }
	    break;
	case FEB:
	case APR:
	case JUN:
	case SEP:
	case NOV:
	    if (day > MAXDAYS_1) {
		day -= MAXDAYS_1;
		month++;
	    }
	    break;
    }

    if (month > MAXMONTH) {
        month -= MAXMONTH;
	year++;
    }

    char tembuf[TIMELEN];

    if (hour<10) {
	strcat(nexttime,"0");
    }

    sprintf(tembuf,"%d:",hour);
    strcat(nexttime,tembuf);

    if (min<10) {
	strcat(nexttime,"0");
    }

    sprintf(tembuf,"%d:",min);
    strcat(nexttime,tembuf);

    strcat(nexttime,secchar);

    sprintf(tembuf,"%d-",year);
    strcat(nextdate,tembuf);

    if (month<10) {
	strcat(nextdate,"0");
    }
    sprintf(tembuf,"%d-",month);
    strcat(nextdate,tembuf);

    if (day<10) {
	strcat(nextdate,"0");
    }
    sprintf(tembuf,"%d",day);
    strcat(nextdate,tembuf);

}

void convert_date(char *eventdate)
{
    int i=0,j=0;
//    int year,month,day;
    char yearchar[TIMELEN],monthchar[TIMELEN],daychar[TIMELEN];

    bzero(yearchar,TIMELEN);
    bzero(monthchar,TIMELEN);
    bzero(daychar,TIMELEN);

//printf("convert_date:before convert:[%s]\n",eventdate);

    //get current event date(year,month,day)
    i=0;
    j=0;
    while(eventdate[i]!='-' && i<strlen(eventdate))
    {
        yearchar[j]=eventdate[i];
        j++;
        i++;
    }

//    month = atoi(monthchar);
    //printf("month:[%d]\n",month);

    j=0;
    i++;
    while(eventdate[i]!='-' && i< strlen(eventdate))
    {
        monthchar[j]=eventdate[i];
        i++;
        j++;
    }
//    day = atoi(daychar);
//    printf("day:[%d]\n",day);

    j=0;
    i++;

    while(eventdate[i]!='\'' && i< strlen(eventdate))
    {
        daychar[j]=eventdate[i];
        i++;
        j++;
    }
//    year = atoi(yearchar);
//    printf("day:[%d]\n",day);

    bzero(eventdate,strlen(eventdate));

    strcpy(eventdate,monthchar);
    strcat(eventdate,"/");
    strcat(eventdate,daychar);
    strcat(eventdate,"/");
    strcat(eventdate,yearchar);

//printf("convert_date:after convert:[%s]\n",eventdate);

}

void del_sec(char *eventtime)
{
    int i=0;
    int count=0;
    while( count < 2 && i<strlen(eventtime) )
    {
    	if (eventtime[i++] ==':' ) {
	    count++;
    	}
    }
    eventtime[--i] = '\0';
}

// schedule the next running of Notarizer and insert the schdule in Event table
void ScheduleNext(char *eventdate, char *eventtime,
                  VerificationParameter *ver_param, SQLHDBC dbc) {
  char notJobFile[FILENAMELEN]="atnotjob";
  char notResFile[FILENAMELEN]="atnotres";
  FILE *notJob;
  FILE *notRes;

  char atcommand[ATCOMLEN]="at -f ";

  char delNotJob[ATCOMLEN]="rm -f ";
  char delNotRes[ATCOMLEN]="rm -f ";

  char nextdate[DATELEN],nexttime[DATELEN];
  char schStpDate[TIMESTPLEN];

  char createID[IDLEN];

  getCreateID(dbc,createID);
  strcat(notJobFile,createID);
  strcat(notResFile,createID);

  // two at command to delete files
  strcat(delNotJob,notJobFile);
  strcat(delNotRes,notResFile);

  // create the at command file for scheduling the Notarizer
  notJob = fopen(notJobFile,"w+");
//printf("Dbpath:%s,Dbname:%s\n",ConfigTable.Dbpath,ConfigTable.Dbname);
    //fprintf(notJob,"/cs/timecenter/tau/audit/auditutilities/notarize %s %s %s >/dev/null 2>&1\n",
  if (ver_param->method == LOCAL_VERIFICATION) {
    fprintf(notJob,"%s/notarizer %s %s %s %s\n",
            ver_param->binary_dir,
            ConfigTable.Dbpath, ConfigTable.Dbname,
            ver_param->binary_dir,ver_param->server_name);
  } else if (ver_param->method == SURETY_VERIFICATION) {
    fprintf(notJob,"%s/notarizer %s %s %s %s %s\n",
            ver_param->binary_dir,
            ConfigTable.Dbpath, ConfigTable.Dbname,
            ver_param->binary_dir, ver_param->surety_user_name,
            ver_param->surety_password);
  }
    //fprintf(notJob,"/cs/timecenter/tau/audit/auditutilities_mz_6_6_2007/notarize %s %s %s\n", ConfigTable.Dbpath,ConfigTable.Dbname,server);

  if (fclose(notJob)) {
    fprintf(stderr, "error source a\n");
    show_my_error();
  }
  // create the at command for next scheduling

  get_next_date(eventdate,eventtime,nextdate,nexttime);
printf("\nnextdate:[%s],nexttime:[%s]\n",nextdate,nexttime);

  // check if the schedule next running time is earlier than current time
  getTimestp(schStpDate,nextdate,nexttime);

  if (cmpSchDate(schStpDate) < 0 ) {
    insErrEvent(dbc,"Notarizer scheduled Date is earlier than current date");
    fprintf(stderr,"\nNotarizer scheduled Date is earlier than current date\n");
    exit(1);
  }

    strcat(atcommand,notJobFile);
    strcat(atcommand," ");

    del_sec(nexttime);
    strcat(atcommand,nexttime);
    strcat(atcommand," ");
    convert_date(nextdate);
    strcat(atcommand,nextdate);

    // redirect the result
    strcat(atcommand," >&");
    notRes = fopen(notResFile,"w+");
    strcat(atcommand,notResFile);

printf("new atcommand:[%s]\n",atcommand);
    //now can set the next execution of Notarizer
    if (system(atcommand) == -1) {
        // error when run Notarizer from shell
        insErrEvent(dbc,"Can't run notarizer");
        fprintf(stderr,"Can't run notarizer");
        exit(1);
    }

   char atbuf[ATRETBUF]; 

   if (fgets(atbuf,ATRETBUF,notRes) != NULL) {
	char *pbuf;
        char atid[IDLEN]; 
        int i=0;

	bzero(atid,IDLEN);

 	pbuf = index(atbuf,' ');
        pbuf++;

        while(pbuf!= NULL && *pbuf != ' ') {
	    atid[i] = *pbuf;
	    pbuf++;
	    i++;
	}

printf("\natid[%s]\n",atid);

	if (pbuf != NULL && atid != NULL) {
	    // get job ID,set next schedule tuple in Event table
	    SQLCHAR insEvent[MAXINSLEN] = "insert into Event (Kind,Path,Name,atID,ScheduledDate) VALUES ('N','";
	    strcat(insEvent,ConfigTable.Dbpath);
	    strcat(insEvent,"','");
	    strcat(insEvent,ConfigTable.Dbname);
	    strcat(insEvent,"',");
	    strcat(insEvent,atid);
	    strcat(insEvent,",'");
	    strcat(insEvent,schStpDate);
	    strcat(insEvent,"')");

printf("\nschedule next Notarizer:[%s]\n",insEvent);
	    exeSqlQuery(dbc,insEvent);
	}

        if (fclose(notRes)) {
            insErrEvent(dbc,"Can't close an open file");
            fprintf(stderr,"Can't close an open file");
            exit(1);
        }


   } else {
       fclose(notRes);
       // can't set at command properly 
       insErrEvent(dbc,"Can't set at command properly");
       fprintf(stderr,"Can't set at command properly");
       exit(1);
   }

printf("delete notJob command:[%s]\n",delNotJob);
    // delete not Job File
    if (system(delNotJob) == -1) {
        insErrEvent(dbc,"Can't delete notJobFile");
    }

printf("delete notRes atcommand:[%s]\n",delNotRes);
    // delete not Res File
    if (system(delNotRes) == -1) {
        insErrEvent(dbc,"Can't delete notResFile");
    }
}


