#include "common.h"
#include <stdio.h>
#include <stdlib.h>
/* tBDB support */
#include "db.h"

void show_error(int source) {
  fprintf(stderr, "error %d\n", source);
//  exit(1);
}


unsigned char ascii_to_val(char a) {
  switch(a){
    case '0': return 0;
    case '1': return 1;
    case '2': return 2;
    case '3': return 3;
    case '4': return 4;
    case '5': return 5;
    case '6': return 6;
    case '7': return 7;
    case '8': return 8;
    case '9': return 9;
    case 'a':
    case 'A': return 10;
    case 'b':
    case 'B': return 11;
    case 'c':
    case 'C': return 12;
    case 'd':
    case 'D': return 13;
    case 'e':
    case 'E': return 14;
    case 'f':
    case 'F': return 15;
  }
}


int str_to_value(char *str, int slen, char *val, int vlen) {
   int i;
   char *c1, *c2, tmp, val2;

   if(slen!=2*vlen){
      return -1;
   }

   c1=str;
   c2=val;
   for(i=0;i<vlen;i++){
      tmp = 0;
      val2 = 0;
      tmp = ascii_to_val(*c1);
      c1++;
      val2 = ascii_to_val(*c1);
      val2 |= (tmp<<4);
      *c2 = val2;
      c1++;
      c2++;
   }
   return 0;
}


int getEmailAddr(SQLHDBC dbc, char *emailAddr, char *Kind)
{
    SQLHSTMT stmt;

    SQLRETURN sqlret; /* ODBC API return status */

    SQLINTEGER indicator;

    SQLSMALLINT columns; /* number of columns in result-set */

    SQLCHAR getEmail[SQLQUERY] = "select Email from IsMaintainedBy where Kind='";

    strcat(getEmail,Kind);
    strcat(getEmail,"' and Path='");

//    if (strcmp(Kind,"A") == 0) {
//        //CSO
//        strcat(getEmail, "Overall' and Name='Overall'");
//    }
//    else {
        strcat(getEmail,ConfigTable.Dbpath);
        strcat(getEmail, "' and Name='");
        strcat(getEmail,ConfigTable.Dbname);
        strcat(getEmail, "'");
//    }

    char buf[MAXEVENTBUF];
    bzero(emailAddr,EMAILLEN);

    int FindEvent = 0;

 /* Allocate a statement handle */
    SQLAllocHandle(SQL_HANDLE_STMT, dbc, &stmt);

    /* read from Configuration table*/
printf("getEmailAddr:[%s]\n",getEmail);

    sqlret = SQLExecDirect(stmt,getEmail,SQL_NTS);


    if (sqlret == SQL_SUCCESS) {
        while (1) {
            sqlret = SQLFetch(stmt);
            if (sqlret == SQL_ERROR || sqlret == SQL_SUCCESS_WITH_INFO) {
                show_error(1);
            }

            if (sqlret == SQL_SUCCESS || sqlret == SQL_SUCCESS_WITH_INFO) {

                FindEvent = 1;

                SQLUSMALLINT i;

                /* How many columns are there */
                SQLNumResultCols(stmt, &columns);

                /* Loop through the columns */
                for (i = 1; i <= columns; i++) {

                    /* retrieve column data as a string */
                    bzero(buf,MAXEVENTBUF);
                    if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, MAXEVENTBUF, &indicator))) {
                        strcpy(emailAddr,buf);

                    }
                }
            } else {
                break;
            }
        }
    }

    return FindEvent;

}



// Get count for 'N' event
int getNotEventCount(SQLHDBC dbc)
{
    SQLHSTMT stmt;

    SQLRETURN sqlret; /* ODBC API return status */

    SQLINTEGER indicator;

    SQLSMALLINT columns; /* number of columns in result-set */

    SQLCHAR getNotCnt[SQLQUERY] = "select COUNT(*) from Event where Kind='N' AND Path='";

    strcat(getNotCnt,ConfigTable.Dbpath);
    strcat(getNotCnt, "' and Name='");
    strcat(getNotCnt,ConfigTable.Dbname);
    strcat(getNotCnt, "'");

    char buf[MAXEVENTBUF];

    int notCount;

 /* Allocate a statement handle */
    SQLAllocHandle(SQL_HANDLE_STMT, dbc, &stmt);

    /* read from Configuration table*/
printf("getNotCnt:[%s]\n",getNotCnt);
    sqlret = SQLExecDirect(stmt,getNotCnt,SQL_NTS);

    if (sqlret == SQL_SUCCESS) {
        while (1) {
            sqlret = SQLFetch(stmt);
            if (sqlret == SQL_ERROR || sqlret == SQL_SUCCESS_WITH_INFO) {
                show_error(2);
            }

            if (sqlret == SQL_SUCCESS || sqlret == SQL_SUCCESS_WITH_INFO) {

                SQLUSMALLINT i;

                /* How many columns are there */
                SQLNumResultCols(stmt, &columns);

                /* Loop through the columns */
                for (i = 1; i <= columns; i++) {

                    /* retrieve column data as a string */
                    bzero(buf,MAXEVENTBUF);
                    if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, MAXEVENTBUF, &indicator))) {
                        notCount = atoi(buf);
                    }
                }
            } else {
                break;
            }
        }
    }

printf("\ngetNotEventCount, event count[%d]\n",notCount);
    return notCount;
}



// Get the corresponding ChainID(in Mono) in Chain table given EventID
void getChainID(SQLHDBC dbc,char *notEventID, char *ChainID)
{
    SQLHSTMT stmt;

    SQLRETURN sqlret; /* ODBC API return status */

    SQLINTEGER indicator;

    SQLSMALLINT columns; /* number of columns in result-set */

    SQLCHAR getchainID[SQLQUERY] = "select ChainID from Chain where Color='black'";

    strcat(getchainID, " and EventID=");
    strcat(getchainID, notEventID);

    int FindEvent = 0;

    char buf[MAXEVENTBUF];
    bzero(ChainID,IDLEN);

 /* Allocate a statement handle */
    SQLAllocHandle(SQL_HANDLE_STMT, dbc, &stmt);

printf("getChainID:[%s]\n",getchainID);

    sqlret = SQLExecDirect(stmt,getchainID,SQL_NTS);

    if (sqlret == SQL_SUCCESS) {
        while (1) {
            sqlret = SQLFetch(stmt);
            if (sqlret == SQL_ERROR || sqlret == SQL_SUCCESS_WITH_INFO) {
                show_error(3);
            }

            if (sqlret == SQL_SUCCESS || sqlret == SQL_SUCCESS_WITH_INFO) {

                FindEvent = 1;
                SQLUSMALLINT i;

                /* How many columns are there */
                SQLNumResultCols(stmt, &columns);

                /* Loop through the columns */
                for (i = 1; i <= columns; i++) {

                    /* retrieve column data as a string */
    		    bzero(buf,MAXEVENTBUF);
                    if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, MAXEVENTBUF, &indicator))) {
                        strcpy(ChainID,buf);
                    }
                }
            } else {
                break;
            }
        }
    }

    if (!FindEvent) {
        // there is no exist any Validator Event
        insErrEvent(dbc,"Can't find ChainID in Chain table during forensic analysis");
        fprintf(stderr,"Can't find ChainID in Chain table during forensic analysis");
        exit(1);
    }

}


// Insert into NotarizationCheck table of the Validation result
void insNotCheck(SQLHDBC dbc,char *ChainID,char *Result, char *notEventID)
{

    SQLCHAR insNotCheckTable[SQLQUERY] = "insert into NotarizationCheck (ChainID,Result,FailureID) VALUES (";

    strcat(insNotCheckTable, ChainID);
    strcat(insNotCheckTable, ",'");
    strcat(insNotCheckTable, Result);
    strcat(insNotCheckTable, "',");
    strcat(insNotCheckTable, notEventID);
    strcat(insNotCheckTable, ")");

printf("\ninsertNotCheck:[%s]\n",insNotCheckTable);
    exeSqlQuery(dbc,insNotCheckTable);

}


// get the most recent tampering dection EventID in the event table
void getTamperID(SQLHDBC dbc,char *curTamperID)
{
    SQLHSTMT stmt;

    SQLRETURN sqlret; /* ODBC API return status */

    SQLINTEGER indicator;

    SQLSMALLINT columns; /* number of columns in result-set */

    SQLCHAR getPrevNot[SQLQUERY] = "select EventID from Event where EventID=( select max(EventID) from Event where Kind='T' and Path='";

    strcat(getPrevNot, ConfigTable.Dbpath);
    strcat(getPrevNot, "' ");
    strcat(getPrevNot, " and Name='");
    strcat(getPrevNot, ConfigTable.Dbname);
    strcat(getPrevNot,"')");

    int FindEvent = 0;

    char buf[MAXEVENTBUF];
    bzero(curTamperID,IDLEN);

 /* Allocate a statement handle */
    SQLAllocHandle(SQL_HANDLE_STMT, dbc, &stmt);

    /* read from Configuration table*/
//printf("getMaxVal:[%s]\n",getMaxVal);
    sqlret = SQLExecDirect(stmt,getPrevNot,SQL_NTS);

    if (sqlret == SQL_SUCCESS) {
        while (1) {
            sqlret = SQLFetch(stmt);
            if (sqlret == SQL_ERROR || sqlret == SQL_SUCCESS_WITH_INFO) {
                show_error(4);
            }

            if (sqlret == SQL_SUCCESS || sqlret == SQL_SUCCESS_WITH_INFO) {

                FindEvent = 1;
                SQLUSMALLINT i;

                /* How many columns are there */
                SQLNumResultCols(stmt, &columns);

                /* Loop through the columns */
                for (i = 1; i <= columns; i++) {

                    /* retrieve column data as a string */
    		    bzero(buf,MAXEVENTBUF);
                    if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, MAXEVENTBUF, &indicator))) {
                        strcpy(curTamperID,buf);
                    }
                }
            } else {
                break;
            }
        }
    }

    if (!FindEvent) {
	// there is no exist any Validator Event
        insErrEvent(dbc,"Can't find any Tampering detection Event during forensic analysis");
        fprintf(stderr,"Can't find any Tampering detection Event during forensic analysis");
	exit(1);
    }

}


// get the datebase create EventID
void getCreateID(SQLHDBC dbc,char *dbCreateID)
{
    SQLHSTMT stmt;

    SQLRETURN sqlret; /* ODBC API return status */

    SQLINTEGER indicator;

    SQLCHAR getCrtID[256] = "select EventID from Event where Kind='C'";

    strcat(getCrtID, " and Path='");
    strcat(getCrtID, ConfigTable.Dbpath);
    strcat(getCrtID, "' ");
    strcat(getCrtID, " and Name='");
    strcat(getCrtID, ConfigTable.Dbname);
    strcat(getCrtID, "'");

    int FindEvent = 0;
    char buf[MAXEVENTBUF];
    bzero(dbCreateID,IDLEN);

printf("\n Get Create EventID:[%s]",getCrtID);

    /* Allocate a statement handle */
    SQLAllocHandle(SQL_HANDLE_STMT, dbc, &stmt);

    /* read from Configuration table*/
    sqlret = SQLExecDirect(stmt,getCrtID,SQL_NTS);

    SQLSMALLINT columns; /* number of columns in result-set */

    if (sqlret == SQL_SUCCESS) {
        while (1) {

            sqlret = SQLFetch(stmt);
            if (sqlret == SQL_ERROR || sqlret == SQL_SUCCESS_WITH_INFO) {
                show_error(5);
            }

            if (sqlret == SQL_SUCCESS || sqlret == SQL_SUCCESS_WITH_INFO) {

                SQLUSMALLINT i;
                FindEvent = 1;

                /* How many columns are there */
                SQLNumResultCols(stmt, &columns);
                for (i = 1; i <= columns; i++)
                {
    		    bzero(buf,MAXEVENTBUF);
                    if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, MAXEVENTBUF, &indicator))) {
                            strcpy(dbCreateID,buf);
                    }
                }
            } else {
                break;
            }
        }
    }

    if (!FindEvent) {
        fprintf(stderr,"There is no CreateDate in Event where Path=%s,Name=%s\n",
                        ConfigTable.Dbpath,ConfigTable.Dbname);
        show_error(6);
    }

}

//Get pervious Notarization Event ID,ActualDate,ActualMilliseconds
void getPreNotEvent(SQLHDBC dbc, char *prevNotID,char *prevSchDate, char *prevActDate, char *prevActMs, char *curNotID)
{
    SQLHSTMT stmt;

    SQLRETURN sqlret; /* ODBC API return status */

    SQLINTEGER indicator;

    SQLSMALLINT columns; /* number of columns in result-set */

    SQLCHAR getPrevNot[SQLQUERY] = "select EventID,ScheduledDate,ActualDate,ActualMilliseconds from Event where EventID=( select max(EventID) from Event where Kind='N' and Path='";

    strcat(getPrevNot, ConfigTable.Dbpath);
    strcat(getPrevNot, "' ");
    strcat(getPrevNot, " and Name='");
    strcat(getPrevNot, ConfigTable.Dbname);
    strcat(getPrevNot, "' and EventID<");
    strcat(getPrevNot, curNotID);
    strcat(getPrevNot, ")");

//printf("\n get previous Not Event:[%s]\n",getPrevNot);

    int FindEvent = 0;

    char buf[MAXEVENTBUF];
    bzero(prevNotID,IDLEN);
    bzero(prevSchDate,TIMESTPLEN);
    bzero(prevActDate,TIMESTPLEN);
    bzero(prevActMs,MSLEN);

    /* Allocate a statement handle */
    SQLAllocHandle(SQL_HANDLE_STMT, dbc, &stmt);

    /* read from Configuration table*/
//printf("getMaxVal:[%s]\n",getMaxVal);
    sqlret = SQLExecDirect(stmt,getPrevNot,SQL_NTS);

    if (sqlret == SQL_SUCCESS) {
        while (1) {
            int i = 1;
            sqlret = SQLFetch(stmt);
            if (sqlret == SQL_ERROR || sqlret == SQL_SUCCESS_WITH_INFO) {
                show_error(7);
            }

            if (sqlret == SQL_SUCCESS || sqlret == SQL_SUCCESS_WITH_INFO) {

                FindEvent = 1;

                /* How many columns are there */
                SQLNumResultCols(stmt, &columns);

 		/* Loop through the columns */
                for (i = 1; i <= columns; i++) {
		    bzero(buf,MAXEVENTBUF);
                    switch(i)
                    {
                    case 1:
                        if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, MAXEVENTBUF, &indicator))) {
                            strcpy(prevNotID,buf);
                        }
                        break;

                    case 2:
                        if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, MAXEVENTBUF, &indicator))) {
                            strcpy(prevSchDate,buf);
                        }
                        break;

                    case 3:
                        if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, MAXEVENTBUF, &indicator))) {
                            strcpy(prevActDate,buf);
                        }
                        break;

                    case 4:
                          if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, MAXEVENTBUF, &indicator))) {
                            strcpy(prevActMs,buf);
                        }
                    }
                }
            } else {
                break;
	    }
        }
    }

    if (!FindEvent) {
	//First 'N",set the previous 'N' Event to be the 'C' Event
	getTimestp(prevActDate,ConfigTable.StartDate,ConfigTable.StartTime);
  	strcpy(prevActMs,"0");
    } 

    if (!strcmp(prevActMs,"")) {
  	strcpy(prevActMs,"0");
    }

}


// get the current granule for Notarization event
int getCurNotGranule(SQLHDBC dbc) {
    SQLHSTMT stmt;

    SQLRETURN sqlret; /* ODBC API return status */

    SQLINTEGER indicator;

    SQLSMALLINT columns; /* number of columns in result-set */

    SQLCHAR getCurNotGle[SQLQUERY] = "select count(EventID) from Event where Kind='N' and Path='";

    strcat(getCurNotGle, ConfigTable.Dbpath);
    strcat(getCurNotGle, "' ");
    strcat(getCurNotGle, " and Name='");
    strcat(getCurNotGle, ConfigTable.Dbname);
    strcat(getCurNotGle, "'");

    char granule[32];

    bzero(granule,32);

//printf("\n get current notarization granule:[%s]\n",getCurNotGle);

    char buf[MAXEVENTBUF];
    bzero(buf,MAXEVENTBUF);

 /* Allocate a statement handle */
    SQLAllocHandle(SQL_HANDLE_STMT, dbc, &stmt);

    /* read from Configuration table*/
    sqlret = SQLExecDirect(stmt,getCurNotGle,SQL_NTS);

    if (sqlret == SQL_SUCCESS) {
        while (1) {
            sqlret = SQLFetch(stmt);
            if (sqlret == SQL_ERROR || sqlret == SQL_SUCCESS_WITH_INFO) {
                show_error(8);
            }

            if (sqlret == SQL_SUCCESS || sqlret == SQL_SUCCESS_WITH_INFO) {

                SQLUSMALLINT i;

                /* How many columns are there */
                SQLNumResultCols(stmt, &columns);

                /* Loop through the columns */
                for (i = 1; i <= columns; i++) {

                    /* retrieve column data as a string */
                    if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, MAXEVENTBUF, &indicator))) {
                        strcpy(granule,buf);
                    }
                }
            } else {
                break;
            }
        }
    }

    return atoi(granule) - 1;

}

// get the current granule for validation event
int getCurValGranule(SQLHDBC dbc)
{
    SQLHSTMT stmt;

    SQLRETURN sqlret; /* ODBC API return status */

    SQLINTEGER indicator;

    SQLSMALLINT columns; /* number of columns in result-set */

    SQLCHAR getCurValGle[SQLQUERY] = "select count(EventID) from Event where Kind='V' and Path='";

    strcat(getCurValGle, ConfigTable.Dbpath);
    strcat(getCurValGle, "' ");
    strcat(getCurValGle, " and Name='");
    strcat(getCurValGle, ConfigTable.Dbname);
    strcat(getCurValGle, "'");

    char granule[32];

    bzero(granule,32);

printf("\n get current validation granule:[%s]\n",getCurValGle);

    char buf[MAXEVENTBUF];
    bzero(buf,MAXEVENTBUF);

 /* Allocate a statement handle */
    SQLAllocHandle(SQL_HANDLE_STMT, dbc, &stmt);

    /* read from Configuration table*/
    sqlret = SQLExecDirect(stmt,getCurValGle,SQL_NTS);

    if (sqlret == SQL_SUCCESS) {
        while (1) {
            sqlret = SQLFetch(stmt);
            if (sqlret == SQL_ERROR || sqlret == SQL_SUCCESS_WITH_INFO) {
                show_error(9);
            }

            if (sqlret == SQL_SUCCESS || sqlret == SQL_SUCCESS_WITH_INFO) {

                SQLUSMALLINT i;

                /* How many columns are there */
                SQLNumResultCols(stmt, &columns);

                /* Loop through the columns */
                for (i = 1; i <= columns; i++) {

                    /* retrieve column data as a string */
                    if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, MAXEVENTBUF, &indicator))) {
                        strcpy(granule,buf);
                    }
                }
            } else {
                break;
            }
        }
    }

    return atoi(granule);
}


// get the previous Notarizer EventID for given current Notarizer EventID
// used by forensic analysis
int getPreNotID(SQLHDBC dbc, char *preNotID, char *curNotID)
{
    SQLHSTMT stmt;

    SQLRETURN sqlret; /* ODBC API return status */

    SQLINTEGER indicator;

    SQLSMALLINT columns; /* number of columns in result-set */

    SQLCHAR getPrevNot[SQLQUERY] = "select EventID from Event where EventID=(select max(EventID) from Event where Kind='N' and Path='";

    strcat(getPrevNot, ConfigTable.Dbpath);
    strcat(getPrevNot, "' ");
    strcat(getPrevNot, " and Name='");
    strcat(getPrevNot, ConfigTable.Dbname);
    strcat(getPrevNot, "' and EventID<");
    strcat(getPrevNot, curNotID);
    strcat(getPrevNot," );");

//printf("\n get previous NotID:[%s]\n",getPrevNot);

    int FindEvent = 0;

    char buf[MAXEVENTBUF];
    bzero(buf,MAXEVENTBUF);
    bzero(preNotID,IDLEN);

 /* Allocate a statement handle */
    SQLAllocHandle(SQL_HANDLE_STMT, dbc, &stmt);

    /* read from Configuration table*/
//printf("getMaxVal:[%s]\n",getPrevNot);
    sqlret = SQLExecDirect(stmt,getPrevNot,SQL_NTS);

    if (sqlret == SQL_SUCCESS) {
        while (1) {
            sqlret = SQLFetch(stmt);
            if (sqlret == SQL_ERROR || sqlret == SQL_SUCCESS_WITH_INFO) {
                show_error(10);
            }

            if (sqlret == SQL_SUCCESS || sqlret == SQL_SUCCESS_WITH_INFO) {

                FindEvent = 1;
                SQLUSMALLINT i;

                /* How many columns are there */
                SQLNumResultCols(stmt, &columns);

                /* Loop through the columns */
                for (i = 1; i <= columns; i++) {

                    /* retrieve column data as a string */
                    if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, MAXEVENTBUF, &indicator))) {
                        strcpy(preNotID,buf);
                    }
                }
            } else {
                break;
            }
        }
    }

    if (!FindEvent) {
        // use the database create EventID to set this value
        getCreateID(dbc,preNotID);
    }

}

// get ActualDate,ActualMilliseconds,EventID from Event table for given sqlquery
// Return value:
// 1 - find one
// 0 - not find "V" event for this database
int getNotEvent(SQLHDBC dbc,SQLCHAR *sqlquery,
	char *notActDate,char *notActMs, char *notEvtID)
{
    SQLHSTMT stmt;

    SQLRETURN sqlret; /* ODBC API return status */

    SQLINTEGER indicator;

    SQLSMALLINT columns; /* number of columns in result-set */

    int FindEvent = 0;

    char buf[MAXEVENTBUF];
    bzero(notActDate,TIMESTPLEN);
    bzero(notActMs,MSLEN);
    bzero(notEvtID,IDLEN);

 /* Allocate a statement handle */
    SQLAllocHandle(SQL_HANDLE_STMT, dbc, &stmt);

    /* read from Configuration table*/
//printf("getMaxVal:[%s]\n",getMaxVal);
    sqlret = SQLExecDirect(stmt,sqlquery,SQL_NTS);

    if (sqlret == SQL_SUCCESS) {
        while (1) {
            int i = 1;
            sqlret = SQLFetch(stmt);
            if (sqlret == SQL_ERROR || sqlret == SQL_SUCCESS_WITH_INFO) {
                show_error(11);
            }

            if (sqlret == SQL_SUCCESS || sqlret == SQL_SUCCESS_WITH_INFO) {

                FindEvent = 1;

                /* How many columns are there */
                SQLNumResultCols(stmt, &columns);

                /* retrieve column data as a string */
                while(i<=columns)
                {
    		    bzero(buf,MAXEVENTBUF);
                    switch(i)
                    {
                    case 1:
                        if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, MAXEVENTBUF, &indicator))) {
                            strcpy(notActDate,buf);
                        }
                        break;

                    case 2:
                        if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, MAXEVENTBUF, &indicator))) {
                            strcpy(notActMs,buf);
                        }
                        break;

                    case 3:
                        if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, MAXEVENTBUF, &indicator))) {
                            strcpy(notEvtID,buf);
                        }
                    }
                    i++;
                }
            } else {
                break;
            }
        }
    }

    return FindEvent;
}



// get Maximum Validator event from Event table
// Return value:
// 1 - find one
// 0 - not find "V" event for this database
int getMaxValEvent(SQLHDBC dbc, char *preValSchDate,char *preValActDate,char *preValActMs)
{
    SQLHSTMT stmt;

    SQLRETURN sqlret; /* ODBC API return status */

    SQLINTEGER indicator;

    SQLSMALLINT columns; /* number of columns in result-set */

    int FindEvent = 0;

    char buf[MAXEVENTBUF];
    bzero(buf,MAXEVENTBUF);
    bzero(preValSchDate,TIMESTPLEN);
    bzero(preValActDate,TIMESTPLEN);
    bzero(preValActMs,MSLEN);

    SQLCHAR getMaxVal[SQLQUERY] = "select ScheduledDate,ActualDate,ActualMilliseconds from Event where EventID=( select max(EventID) from Event where Kind='V' and Path='";

    strcat(getMaxVal, ConfigTable.Dbpath);
    strcat(getMaxVal, "' ");
    strcat(getMaxVal, " and Name='");
    strcat(getMaxVal, ConfigTable.Dbname);
    strcat(getMaxVal, "')");

    /* Allocate a statement handle */
    SQLAllocHandle(SQL_HANDLE_STMT, dbc, &stmt);

    /* read from Configuration table*/
printf("getMaxValEvent:[%s]\n",getMaxVal);
    sqlret = SQLExecDirect(stmt,getMaxVal,SQL_NTS);

    if (sqlret == SQL_SUCCESS) {
        while (1) {
            int i = 1;
            sqlret = SQLFetch(stmt);
            if (sqlret == SQL_ERROR || sqlret == SQL_SUCCESS_WITH_INFO) {
                show_error(12);
            }

            if (sqlret == SQL_SUCCESS || sqlret == SQL_SUCCESS_WITH_INFO) {

 		FindEvent = 1;

                /* How many columns are there */
                SQLNumResultCols(stmt, &columns);

                /* retrieve column data as a string */
                while(i<=columns)
                {
                    switch(i)
                    {
                    case 1:
                        if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, sizeof(buf), &indicator))) {
                            strcpy(preValSchDate,buf);
                        }
                        break;

                    case 2:
                        if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, sizeof(buf), &indicator))) {
                            strcpy(preValActDate,buf);
			}
                        break;

                    case 3:
                        if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, sizeof(buf), &indicator))) {
                            strcpy(preValActMs,buf);
                        }
                    }
                    i++;
                }
            } else {
                break;
            }
        }
    }

    return FindEvent;
}


// Get current Notarization Event   
void getCurNotEvent(SQLHDBC dbc, char *curEventID,char *curSchDate)
{
    SQLHSTMT stmt;

    SQLRETURN sqlret; /* ODBC API return status */

    SQLINTEGER indicator;

    SQLSMALLINT columns; /* number of columns in result-set */

    int FindEvent = 0;

    char buf[MAXEVENTBUF];

    bzero(curEventID,IDLEN);
    bzero(curSchDate,TIMESTPLEN);

    SQLCHAR getMaxNot[SQLQUERY] = "select EventID,ScheduledDate from Event where EventID=(select max(EventID) from Event where Kind='N' and Path='";

    strcat(getMaxNot, ConfigTable.Dbpath);
    strcat(getMaxNot, "' ");
    strcat(getMaxNot, " and Name='");
    strcat(getMaxNot, ConfigTable.Dbname);
    strcat(getMaxNot, "')");

printf("\ngetCurNotEvent:[%s]\n",getMaxNot);

 /* Allocate a statement handle */
    SQLAllocHandle(SQL_HANDLE_STMT, dbc, &stmt);

    /* read from Configuration table*/
    sqlret = SQLExecDirect(stmt,getMaxNot,SQL_NTS);

    if (sqlret == SQL_SUCCESS) {
        while (1) {
            int i=1;
            sqlret = SQLFetch(stmt);
            if (sqlret == SQL_ERROR || sqlret == SQL_SUCCESS_WITH_INFO) {
                show_error(13);
            }

            if (sqlret == SQL_SUCCESS || sqlret == SQL_SUCCESS_WITH_INFO) {

                FindEvent = 1;

                /* How many columns are there */
                SQLNumResultCols(stmt, &columns);

                /* retrieve column data as a string */
                while(i<=columns)
                {
    		    bzero(buf,MAXEVENTBUF);
                    switch(i)
                    {
                    case 1:
                        if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, MAXEVENTBUF, &indicator))) {
                            strcpy(curEventID,buf);
                        }
                        break;

                    case 2:
                        if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, MAXEVENTBUF, &indicator))) {
                            strcpy(curSchDate,buf);
                         }
                    }
                    i++;
                }
            } else {
                break;
            }
        }
    }
    if (!FindEvent) {
        insErrEvent(dbc,"Event table has no EventID");
	fprintf(stderr,"\nEvent table has no EventID\n");
        show_error(14);
    }
}


// get the most recent notarizer event
// return value:
// 1 - find such event
// 0 - not find
int getMaxNotEvent(SQLHDBC dbc, char *schDate, char *actDate, char *actMs)
{
    SQLHSTMT stmt;

    SQLRETURN sqlret; /* ODBC API return status */

    SQLINTEGER indicator;

    SQLSMALLINT columns; /* number of columns in result-set */

    int FindEvent = 0;

    char buf[MAXEVENTBUF];

    bzero(schDate,TIMESTPLEN);
    bzero(actDate,TIMESTPLEN);
    bzero(actMs,MSLEN);

    SQLCHAR getMaxNot[SQLQUERY] = "select ScheduledDate,ActualDate,ActualMilliseconds from Event where EventID=(select max(EventID) from Event where Kind='N' and Path='";

    strcat(getMaxNot, ConfigTable.Dbpath);
    strcat(getMaxNot, "' ");
    strcat(getMaxNot, " and Name='");
    strcat(getMaxNot, ConfigTable.Dbname);
    strcat(getMaxNot, "')");

printf("getMaxNotEvent:[%s]\n",getMaxNot);
 /* Allocate a statement handle */
    SQLAllocHandle(SQL_HANDLE_STMT, dbc, &stmt);

    /* read from Configuration table*/
    sqlret = SQLExecDirect(stmt,getMaxNot,SQL_NTS);

    if (sqlret == SQL_SUCCESS) {
        while (1) {
            int i=1;
            sqlret = SQLFetch(stmt);
            if (sqlret == SQL_ERROR || sqlret == SQL_SUCCESS_WITH_INFO) {
                show_error(15);
            }

            if (sqlret == SQL_SUCCESS || sqlret == SQL_SUCCESS_WITH_INFO) {

                FindEvent = 1;

                /* How many columns are there */
                SQLNumResultCols(stmt, &columns);

                /* retrieve column data as a string */
                while(i<=columns)
                {
    		    bzero(buf,MAXEVENTBUF);
                    switch(i)
                    {
                    case 1:
                        if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, MAXEVENTBUF, &indicator))) {
                            strcpy(schDate,buf);
                        }
                        break;

                    case 2:
                        if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, MAXEVENTBUF, &indicator))) {
                            strcpy(actDate,buf);
                        }
                        break;

                    case 3:
                        if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, MAXEVENTBUF, &indicator))) {
                            strcpy(actMs,buf);
                        }
                    }
                    i++;
                }
            } else {
                break;
            }
        }
    }

    return FindEvent;

}

void getMaxValID(SQLHDBC dbc, char *maxValID)
{
    SQLHSTMT stmt;

    SQLRETURN sqlret; /* ODBC API return status */

    SQLINTEGER indicator;

    SQLSMALLINT columns; /* number of columns in result-set */

    int FindEvent = 0;

    char buf[MAXEVENTBUF];
    bzero(maxValID,IDLEN);

    SQLCHAR getMaxVal[SQLQUERY] = "select MAX(EventID) from Event where Kind='V'";

    strcat(getMaxVal, " and Path='");
    strcat(getMaxVal, ConfigTable.Dbpath);
    strcat(getMaxVal, "' ");
    strcat(getMaxVal, " and Name='");
    strcat(getMaxVal, ConfigTable.Dbname);
    strcat(getMaxVal, "'");

printf("getMaxValID:[%s]\n",getMaxVal);

   /* Allocate a statement handle */
   SQLAllocHandle(SQL_HANDLE_STMT, dbc, &stmt);

   //get EventID(foreign key) from Event table first
   sqlret = SQLExecDirect(stmt,getMaxVal,SQL_NTS);


    if (sqlret == SQL_SUCCESS) {
        while (1) {
            sqlret = SQLFetch(stmt);
            if (sqlret == SQL_ERROR || sqlret == SQL_SUCCESS_WITH_INFO) {
                show_error(16);
            }

            if (sqlret == SQL_SUCCESS || sqlret == SQL_SUCCESS_WITH_INFO) {

                FindEvent = 1;
                SQLUSMALLINT i;

                /* How many columns are there */
                SQLNumResultCols(stmt, &columns);

                /* Loop through the columns */
                for (i = 1; i <= columns; i++) {
                    bzero(buf,MAXEVENTBUF);

                    /* retrieve column data as a string */
                    if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, MAXEVENTBUF, &indicator))) {
                        strcpy(maxValID,buf);
                    }
                }
            } else {
                break;
            }
        }
    }

    if (!FindEvent) {
        insErrEvent(dbc,"Event table has no EventID corresponding the current validation event");
        show_error(17);
    }


}

// used as foreign key when insert into Chain table  in alg.c
void getMaxNotID(SQLHDBC dbc,char *maxNotID)
{
    SQLHSTMT stmt;

    SQLRETURN sqlret; /* ODBC API return status */

    SQLINTEGER indicator;

    SQLSMALLINT columns; /* number of columns in result-set */
 
    int FindEvent = 0;

    char buf[MAXEVENTBUF];
    bzero(maxNotID,IDLEN);

    SQLCHAR getNewMaxNot[SQLQUERY] = "select MAX(EventID) from Event where Kind='N'";

    strcat(getNewMaxNot, " and Path='");
    strcat(getNewMaxNot, ConfigTable.Dbpath);
    strcat(getNewMaxNot, "' ");
    strcat(getNewMaxNot, " and Name='");
    strcat(getNewMaxNot, ConfigTable.Dbname);
    strcat(getNewMaxNot, "'");

   /* Allocate a statement handle */
   SQLAllocHandle(SQL_HANDLE_STMT, dbc, &stmt);

   //get EventID(foreign key) from Event table first
   sqlret = SQLExecDirect(stmt,getNewMaxNot,SQL_NTS);

    if (sqlret == SQL_SUCCESS) {
        while (1) {
            sqlret = SQLFetch(stmt);
            if (sqlret == SQL_ERROR || sqlret == SQL_SUCCESS_WITH_INFO) {
                show_error(18);
            }

            if (sqlret == SQL_SUCCESS || sqlret == SQL_SUCCESS_WITH_INFO) {

		FindEvent = 1;
                SQLUSMALLINT i;

                /* How many columns are there */
                SQLNumResultCols(stmt, &columns);

                /* Loop through the columns */
                for (i = 1; i <= columns; i++) {
    		    bzero(buf,MAXEVENTBUF);

                    /* retrieve column data as a string */
                    if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, MAXEVENTBUF, &indicator))) {
                        strcpy(maxNotID,buf);
                    }
                }
            } else {
                break;
            }
        }
    }

    if (!FindEvent) {
        insErrEvent(dbc,"Event table has no EventID corresponding the new Chain");
        show_error(19);
    }
}


// check if the chain is existing in Chain table. If exists, get the chainID and return 1
int IsChainExist(SQLHDBC dbc, char *color, char *notEventID,char *startActDate, char *startActMs, char *stopActDate, char *stopActMs, char *chainID)
{
    SQLHSTMT stmt;

    SQLRETURN sqlret; /* ODBC API return status */

    SQLINTEGER indicator;

    SQLSMALLINT columns; /* number of columns in result-set */

    int FindEvent = 0;

    char buf[MAXEVENTBUF];
    bzero(chainID,IDLEN);

    SQLCHAR isChain[SQLQUERY] = "select ChainID from Chain where EventID=";

    strcat(isChain, notEventID);
    strcat(isChain, " and Color='");
    strcat(isChain, color);
    strcat(isChain, "' and StartDate='");
    strcat(isChain, startActDate);
    strcat(isChain, "' and StartMilliseconds=");
    strcat(isChain, startActMs);
    strcat(isChain, " and StopDate='");
    strcat(isChain, stopActDate);
    strcat(isChain, "' and StopMilliseconds=");
    strcat(isChain, stopActMs);

printf("IsChainExist:[%s]\n",isChain);

   /* Allocate a statement handle */
   SQLAllocHandle(SQL_HANDLE_STMT, dbc, &stmt);

   //get EventID(foreign key) from Event table first
   sqlret = SQLExecDirect(stmt,isChain,SQL_NTS);

    if (sqlret == SQL_SUCCESS) {
        while (1) {
            sqlret = SQLFetch(stmt);
            if (sqlret == SQL_ERROR || sqlret == SQL_SUCCESS_WITH_INFO) {
                show_error(20);
            }

            if (sqlret == SQL_SUCCESS || sqlret == SQL_SUCCESS_WITH_INFO) {

                FindEvent = 1;
                SQLUSMALLINT i;

                /* How many columns are there */
                SQLNumResultCols(stmt, &columns);

                /* Loop through the columns */
                for (i = 1; i <= columns; i++) {
                    bzero(buf,MAXEVENTBUF);

                    /* retrieve column data as a string */
                    if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, MAXEVENTBUF, &indicator))) {
                        strcpy(chainID,buf);
                    }
                }

            } else {
                break;
            }
        }
    }

    if (!FindEvent) {
	printf("Chain not Exist!!\n");
	return 0;
    }
    else {
	printf("Chain DOES Exist!!\n");
    	return 1;
    }
}


// get the startDate/stopDate and StartMillisecond/stopMillisecond for given ChainID
void getChainInfo(SQLHDBC dbc,char *startActDate, char *startActMs, char *stopActDate, char *stopActMs, char *eventID, char *chainID)
{
    SQLHSTMT stmt;

    SQLRETURN sqlret; /* ODBC API return status */

    SQLINTEGER indicator;

    SQLSMALLINT columns; /* number of columns in result-set */

    int FindEvent = 0;

    char buf[MAXEVENTBUF];
    bzero(startActDate,TIMESTPLEN);
    bzero(startActMs,MSLEN);
    bzero(stopActDate,TIMESTPLEN);
    bzero(stopActMs,MSLEN);
    bzero(eventID,IDLEN);

    SQLCHAR getChain[SQLQUERY] = "select StartDate,StartMilliseconds,StopDate,StopMilliseconds,EventID from Chain where ChainID=";

    strcat(getChain, chainID);

printf("getChain:[%s]\n",getChain);

   /* Allocate a statement handle */
   SQLAllocHandle(SQL_HANDLE_STMT, dbc, &stmt);

   //get EventID(foreign key) from Event table first
   sqlret = SQLExecDirect(stmt,getChain,SQL_NTS);


    if (sqlret == SQL_SUCCESS) {
        while (1) {
	    int i=1;
            sqlret = SQLFetch(stmt);
            if (sqlret == SQL_ERROR || sqlret == SQL_SUCCESS_WITH_INFO) {
                show_error(21);
            }

            if (sqlret == SQL_SUCCESS || sqlret == SQL_SUCCESS_WITH_INFO) {

                FindEvent = 1;

                /* How many columns are there */
                SQLNumResultCols(stmt, &columns);

                /* retrieve column data as a string */
                while(i<=columns)
                {
                    bzero(buf,MAXEVENTBUF);
                    switch(i)
                    {
                    case 1:
                        if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, MAXEVENTBUF, &indicator))) {
                            strcpy(startActDate,buf);
                        }
                        break;

                    case 2:
                        if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, MAXEVENTBUF, &indicator))) {
                            strcpy(startActMs,buf);
                        }
                        break;

                    case 3:
                        if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, MAXEVENTBUF, &indicator))) {
                            strcpy(stopActDate,buf);
                        }
                        break;

                    case 4:
                        if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, MAXEVENTBUF, &indicator))) {
                            strcpy(stopActMs,buf);
                        }
                        break;

                    case 5:
                        if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, MAXEVENTBUF, &indicator))) {
                            strcpy(eventID,buf);
                        }
                    }
                    i++;
                }

            } else {
                break;
            }
        }
    }


    if (!FindEvent) {
        insErrEvent(dbc,"Chain table has no this Chain");
        show_error(22);
    }

}


void getEventDate(SQLHDBC dbc, char *eventID, char *ActDate, char *ActMs)
{
    SQLHSTMT stmt;

    SQLRETURN sqlret; /* ODBC API return status */

    SQLINTEGER indicator;

    SQLSMALLINT columns; /* number of columns in result-set */

    int FindEvent = 0;

    char buf[MAXEVENTBUF];
    bzero(ActDate,TIMESTPLEN);
    bzero(ActMs,MSLEN);

    SQLCHAR getEvent[SQLQUERY] = "select ActualDate,ActualMilliseconds from Event where EventID=";

    strcat(getEvent, eventID);

printf("getEventDate:[%s]\n",getEvent);

   /* Allocate a statement handle */
   SQLAllocHandle(SQL_HANDLE_STMT, dbc, &stmt);

   //get EventID(foreign key) from Event table first
   sqlret = SQLExecDirect(stmt,getEvent,SQL_NTS);

    if (sqlret == SQL_SUCCESS) {
        while (1) {
            int i=1;
            sqlret = SQLFetch(stmt);
            if (sqlret == SQL_ERROR || sqlret == SQL_SUCCESS_WITH_INFO) {
                show_error(23);
            }

            if (sqlret == SQL_SUCCESS || sqlret == SQL_SUCCESS_WITH_INFO) {

                FindEvent = 1;

                /* How many columns are there */
                SQLNumResultCols(stmt, &columns);

                /* retrieve column data as a string */
                while(i<=columns)
                {
                    bzero(buf,MAXEVENTBUF);
                    switch(i)
                    {
                    case 1:
                        if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, MAXEVENTBUF, &indicator))) {
                            strcpy(ActDate,buf);
                        }
                        break;

                    case 2:
                        if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, MAXEVENTBUF, &indicator))) {
                            strcpy(ActMs,buf);
                        }
                     }
                    i++;
                }

            } else {
                break;
            }
        }
    }


    if (!FindEvent) {
        insErrEvent(dbc,"Event table has no this Event");
        show_error(24);
    }


}


/*
// get next available atID from Event table
int getAvaAtID(SQLHDBC dbc)
{
    int maxatID = 0;
    SQLHSTMT stmt;

    SQLRETURN sqlret; 

    SQLINTEGER indicator;

    SQLSMALLINT columns; 


    char buf[MAXEVENTBUF];
    bzero(buf,MAXEVENTBUF);

    // get maximum atID given Path/Name
    SQLCHAR sqlMaxatID[SQLQUERY] = "select MAX(atID) from Event where Path='";

    strcat(sqlMaxatID,ConfigTable.Dbpath);
    strcat(sqlMaxatID, "' ");
    strcat(sqlMaxatID, " and Name='");
    strcat(sqlMaxatID, ConfigTable.Dbname);
    strcat(sqlMaxatID, "'");


    // Allocate a statement handle
    SQLAllocHandle(SQL_HANDLE_STMT, dbc, &stmt);

    // read from Configuration table
//printf("getMaxatID:[%s]\n",sqlMaxatID);
    sqlret = SQLExecDirect(stmt,sqlMaxatID,SQL_NTS);

    if (sqlret == SQL_SUCCESS) {
        while (1) {

            sqlret = SQLFetch(stmt);
            if (sqlret == SQL_ERROR || sqlret == SQL_SUCCESS_WITH_INFO) {
                show_error();
            }

            if (sqlret == SQL_SUCCESS || sqlret == SQL_SUCCESS_WITH_INFO) {

                SQLUSMALLINT i;

                SQLNumResultCols(stmt, &columns);

                // Loop through the columns 
                for (i = 1; i <= columns; i++) {

                    if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, sizeof(buf), &indicator))) {
                        maxatID = atoi(buf);
                    }
                }
            } else {
                break;
            }

        }
    }
    return ++maxatID;
}
*/

void exeSqlQuery(SQLHDBC dbc, char *insertSql)
{
    SQLHSTMT stmt;

    SQLRETURN sqlret; /* ODBC API return status */

    //char errorinfo[ERRORINFO];

   /* Allocate a statement handle */
    SQLAllocHandle(SQL_HANDLE_STMT, dbc, &stmt);

    sqlret = SQLExecDirect(stmt,insertSql,SQL_NTS);

   if (!SQL_SUCCEEDED(sqlret)) {
	//sprintf(errorinfo,"Error in execute this Sql insert [%s]",insertSql);
        //insErrEvent(dbc,errorinfo);
        insErrEvent(dbc,"Error in execute Sql query");
	show_error(25);
   }

}

// insert an error event into event table
void insErrEvent(SQLHDBC dbc, char *errinfo)
{
    struct timeval current_t;

    char actual_date[TIMESTPLEN];
    bzero(actual_date,TIMESTPLEN);

    SQLCHAR insErrSql[MAXERREVT] = "insert into Event (Path,Name,Kind,Info,ActualDate) VALUES ('";

    strcat(insErrSql,ConfigTable.Dbpath);
    strcat(insErrSql, "','");
    strcat(insErrSql, ConfigTable.Dbname);
    strcat(insErrSql, "','E','");
    strcat(insErrSql, errinfo);
    strcat(insErrSql, "','");

    gettimeofday(&current_t,NULL);
    strftime(actual_date,TIMESTPLEN,"%Y-%m-%d %X",localtime(&(current_t.tv_sec)));
    //strftime(actual_date,30,"%Y-%m-%d",localtime(&(current_t.tv_sec)));
    //strftime(actual_time,30,"%X",localtime(&(current_t.tv_sec)));

    strcat(insErrSql,actual_date);
    strcat(insErrSql,"')");

//printf("try to insert an error:[%s]\n",insErrSql);

    exeSqlQuery(dbc,insErrSql);

printf("insert an ERROR event into database\n %s\n", insErrSql);
}

 // check if the schedule next running time is earlier than current time
int cmpSchDate(char *SchDate)
{
    struct timeval current_t;
    char curActDate[TIMESTPLEN];

    gettimeofday(&current_t,NULL);
    strftime(curActDate,TIMESTPLEN,"%Y-%m-%d %X",localtime(&(current_t.tv_sec)));

    return strcmp(SchDate,curActDate);
}


void ErrorCheck(void)
{
    if (ConfigTable.Algorithm == NULL) {
        printf("No Algorithm defined in the Configuration Table\n");
        exit (1);
    }


    if (ConfigTable.Dbpath == NULL) {
        printf("No env_dir defined in the Configuration Table\n");
        exit (1);
    }

    if (ConfigTable.Dbname == NULL) {
        printf("No dbname defined in the Configuration Table\n");
        exit (1);
    }
}

void getTimestp(char *timestp, char *date, char *time)
{
    bzero(timestp,TIMESTPLEN);
    strcpy(timestp,date);
    strcat(timestp," ");
    strcat(timestp,time);
}

void getDate(char *timestp, char *date, char *time)
{
    int i,j;
 
    bzero(date,DATELEN);
    bzero(time,DATELEN);

    for (i=0;i<strlen(timestp);i++)
    {
        if (timestp[i] == ' ')
                break;
        date[i] = timestp[i];
    }

    i++;
    for (i,j=0;i<strlen(timestp);i++,j++)
    {
        time[j] = timestp[i];
    }
}


void getStartDate(SQLHDBC dbc)
{
    SQLHSTMT stmt;

    SQLRETURN sqlret; /* ODBC API return status */

    SQLINTEGER indicator;

    SQLCHAR getCDate[256] = "select ActualDate from Event where EventID=( select max(EventID) from Event where Kind='C' and Path='";

    strcat(getCDate, ConfigTable.Dbpath);
    strcat(getCDate, "' ");
    strcat(getCDate, " and Name='");
    strcat(getCDate, ConfigTable.Dbname);
    strcat(getCDate, "')");

    int FindEvent = 0;
    char buf[MAXEVENTBUF];

    char StartTimestp[TIMESTPLEN];
    bzero(StartTimestp,TIMESTPLEN);

printf("\ngetStartDate:[%s]\n",getCDate);

    /* Allocate a statement handle */
    SQLAllocHandle(SQL_HANDLE_STMT, dbc, &stmt);

    /* read from Configuration table*/
    sqlret = SQLExecDirect(stmt,getCDate,SQL_NTS);

    SQLSMALLINT columns; /* number of columns in result-set */

    if (sqlret == SQL_SUCCESS) {
        while (1) {

            sqlret = SQLFetch(stmt);
            if (sqlret == SQL_ERROR || sqlret == SQL_SUCCESS_WITH_INFO) {
                show_error(26);
            }

            if (sqlret == SQL_SUCCESS || sqlret == SQL_SUCCESS_WITH_INFO) {

                SQLUSMALLINT i;
                FindEvent = 1;

                /* How many columns are there */
                SQLNumResultCols(stmt, &columns);
                for (i = 1; i <= columns; i++)
                {
		    bzero(buf,MAXEVENTBUF);

                    if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, MAXEVENTBUF, &indicator))) {
                            strcpy(StartTimestp,buf);
                    }
                }
            } else {
                break;
            }
        }
    } else {
        SQLINTEGER native;
        SQLCHAR state[7];
        SQLCHAR text[256];
        SQLSMALLINT txt_len;
        SQLSMALLINT type = SQL_HANDLE_DBC;
        SQLGetDiagRec(type, dbc, 1, state, &native, text, 256, &txt_len);
        fprintf(stderr, "%s %d: %s\n", state, native, text);

    }

    if (!FindEvent) {
        fprintf(stderr,"There is no CreateDate in Event where Path=%s,Name=%s\n",
                        ConfigTable.Dbpath,ConfigTable.Dbname);
        show_error(27);
    }

    getDate(StartTimestp,ConfigTable.StartDate,ConfigTable.StartTime);

printf("\nCreate Date:[%s],CreateTime:[%s]\n",ConfigTable.StartDate,ConfigTable.StartTime);
}


// Created By Man Nov,2006
//To read configuration from Configuration Table
void ReadConf(SQLHDBC dbc)
{
    SQLHSTMT stmt;
    SQLRETURN ret; /* ODBC API return status */
    SQLSMALLINT columns; /* number of columns in result-set */
    int row = 1;
    SQLINTEGER indicator;
    char buf[MAXEVENTBUF];
    //SQLUSMALLINT i=1;
    SQLCHAR getConfCol[] = "describe Configuration";
    SQLCHAR getConfInf[MAXSQLQUERY] = "select * from Configuration where Path='";

    strcat(getConfInf,ConfigTable.Dbpath);
    strcat(getConfInf,"' AND Name='");
    strcat(getConfInf,ConfigTable.Dbname);
    strcat(getConfInf,"' ORDER BY StoredDate");
printf("********getConfInf SQL query:%s\n",getConfInf);

    /* Allocate a statement handle */
    SQLAllocHandle(SQL_HANDLE_STMT, dbc, &stmt);

    //get Configuration Column names
    ret = SQLExecDirect(stmt,getConfCol,SQL_NTS);
    /* "describe Configuration" 
	+---------------------------+-------------+------+-----+---------------------+-------+
	| Field                     | Type        | Null | Key | Default             | Extra |
	+---------------------------+-------------+------+-----+---------------------+-------+
	| StoredDate                | timestamp   | NO   | PRI | CURRENT_TIMESTAMP   |       | 
	| NotIntDays                | tinyint(4)  | NO   |     |                     |       | 
	| NotIntHrs                 | tinyint(4)  | NO   |     |                     |       | 
	| NotIntMins                | tinyint(4)  | NO   |     |                     |       | 
	| ValidationFactor          | tinyint(4)  | NO   |     |                     |       | 
	| Algorithm                 | varchar(35) | NO   |     |                     |       | 
	| NumLevels                 | tinyint(4)  | NO   |     |                     |       | 
	| Name                      | char(35)    | NO   | PRI |                     |       | 
	| Path                      | char(100)   | NO   | PRI |                     |       | 
	| NotarizationScheduledDate | timestamp   | NO   |     | 1970-01-01 00:00:00 |  
    */

    /* Loop through the rows in the result-set */
    if (ret == SQL_SUCCESS) {
        while(1) {
            ret = SQLFetch(stmt);
            if (ret == SQL_ERROR || ret == SQL_SUCCESS_WITH_INFO) {
                show_error(28);
            }

            if (ret == SQL_SUCCESS || ret == SQL_SUCCESS_WITH_INFO) {

                SQLUSMALLINT i = 1;

                /* retrieve the first column data */
		bzero(buf,MAXEVENTBUF);

                ret = SQLGetData(stmt, i, SQL_C_CHAR,
                             buf, MAXEVENTBUF, &indicator);

                if (SQL_SUCCEEDED(ret)) {

                    /* Handle null columns */
                    if (indicator == SQL_NULL_DATA) strcpy(buf, "NULL");
                    printf("  row %d,Column %d : %s\n", row,i, buf);

                    getConfigTablerow(buf,row);
                }
                row++;
		
            }
            else break;
        }
    }

    /* Allocate a statement handle */
    SQLAllocHandle(SQL_HANDLE_STMT, dbc, &stmt);

   /* read from Configuration table*/
   //SQLExecDirect(stmt,"select * from Configuration" ,SQL_NTS);
   ret = SQLExecDirect(stmt,getConfInf,SQL_NTS);

    /* Loop through the rows in the result-set */
    if (ret == SQL_SUCCESS) {
        int dbExist = 0;
        while(1) {
            ret = SQLFetch(stmt);
            if (ret == SQL_ERROR || ret == SQL_SUCCESS_WITH_INFO) {
                show_error(29);
            }
            if (ret == SQL_SUCCESS || ret == SQL_SUCCESS_WITH_INFO) {
                dbExist = 1;
                SQLUSMALLINT i = 1;

                /* How many columns are there */
                SQLNumResultCols(stmt, &columns);

                /* Loop through the columns */
                for (i = 1; i <= columns; i++) {

		     bzero(buf,MAXEVENTBUF);
                     ret = SQLGetData(stmt, i, SQL_C_CHAR,
                             buf, MAXEVENTBUF, &indicator);

                    if (SQL_SUCCEEDED(ret)) {

                        /* Handle null columns */
                        if (indicator == SQL_NULL_DATA) strcpy(buf, "NULL");
                        printf("  Column %d : %s\n", i, buf);

                        setConfigTable(buf,i);
                    }
                }

//		break;
            }
            else {
                if (!dbExist) {
 		    insErrEvent(dbc,"The Datebase doesn't exist in Configuration table");
                    fprintf(stderr,"Error! The Database[%s/%s] doesn't exist!\n",
					ConfigTable.Dbpath,ConfigTable.Dbname);
                    exit(1);
                }
                break;
            }
        }
    }
}

//set ConfigTable by the SQL result set
void setConfigTable(char *buf,int i)
{
    /* Initialize the global variables */
    if (i == ConfigTable.AlgColNum) {
        strcpy(ConfigTable.Algorithm,buf);
        return;
    }

    if (i == ConfigTable.NotIntDaysColNum) {
        ConfigTable.NotIntDays = atoi(buf);
        return;
    }

    if (i == ConfigTable.NotIntHrsColNum) {
        ConfigTable.NotIntHrs = atoi(buf);
        return;
    }

    if (i == ConfigTable.NotIntMinsColNum) {
        ConfigTable.NotIntMins = atoi(buf);
        return;
    }

    if (i == ConfigTable.StoredDateColNum) {
        strcpy(ConfigTable.StoredDate,buf);
        return;
    }

/*    if (i ==  ConfigTable.DbpathColNum) {
        strcpy(ConfigTable.Dbpath,buf);
        return;
    }

    if (i ==  ConfigTable.DbnameColNum) {
        strcpy(ConfigTable.Dbname,buf);
        return;
    }
*/

    if (i ==  ConfigTable.VFactorColNum) {
        ConfigTable.VFactor = atoi(buf);
        return;
    }

    if (i ==  ConfigTable.NumLevelsColNum) {
        ConfigTable.NumLevels = atoi(buf);
        return;
    }

    if (i ==  ConfigTable.NSchDateColNum) {
	strcpy(ConfigTable.NSchDate,buf);
    }
}

void getConfigTablerow(char *buf,int row)
{
    /* Initialize the global variables */
    if (!strcmp(buf,"Algorithm")) {
        ConfigTable.AlgColNum = row;
        return;
    }

    if (!strcmp(buf,"NotIntDays")) {
        ConfigTable.NotIntDaysColNum = row;
        return;
    }

    if (!strcmp(buf,"NotIntHrs")) {
        ConfigTable.NotIntHrsColNum = row;
        return;
    }

    if (!strcmp(buf,"NotIntMins")) {
        ConfigTable.NotIntMinsColNum = row;
        return;
    }

    if (!strcmp(buf,"StoredDate")) {
        ConfigTable.StoredDateColNum = row;
        return;
    }

    if (!strcmp(buf,"Path")) {
        ConfigTable.DbpathColNum = row;
        return;
    }

    if (!strcmp(buf,"Name")) {
        ConfigTable.DbnameColNum = row;
        return;
    }

    if (!strcmp(buf,"ValidationFactor")) {
        ConfigTable.VFactorColNum = row;
        return;
    }

    if (!strcmp(buf,"NumLevels")) {
        ConfigTable.NumLevelsColNum = row;
        return;
    }

    if (!strcmp(buf,"NotarizationScheduledDate")) {
        ConfigTable.NSchDateColNum = row;
    }
}


// Created By Man Nov,2006
// Initialize ConfigTable
void InitConfigTable()
{
    ConfigTable.AlgColNum = 0;
    ConfigTable.Algorithm[0] = '\0';

    ConfigTable.NotIntDaysColNum = 0;
    ConfigTable.NotIntDays = 0;

    ConfigTable.NotIntHrsColNum = 0;
    ConfigTable.NotIntHrs = 0;

    ConfigTable.NotIntMinsColNum = 0;
    ConfigTable.NotIntMins = 0;

    bzero(ConfigTable.StartDate,DATELEN);
    bzero(ConfigTable.StartTime,DATELEN);

    ConfigTable.DbpathColNum = 0;
    bzero(ConfigTable.Dbpath,DBPATHLEN);

    ConfigTable.DbnameColNum = 0;
    bzero(ConfigTable.Dbname,DBNAMELEN);

    ConfigTable.VFactorColNum = 0;
    ConfigTable.VFactor = 0;

    ConfigTable.StoredDateColNum = 0;
    bzero(ConfigTable.StoredDate,TIMESTPLEN);

    ConfigTable.NumLevelsColNum = 0;
    ConfigTable.NumLevels = 0;

    ConfigTable.NSchDateColNum = 0;
    bzero(ConfigTable.NSchDate,TIMESTPLEN);
}




// Created By Man Nov,2006
// For debug only. Print ConfigTable
void PrintConfigTable()
{
    printf("++++++ConfigTable+++++++++++\n");
    printf("AlgColNum:\t %d \n",ConfigTable.AlgColNum);
    printf("Algorithm:\t %s \n",ConfigTable.Algorithm);
    printf("NotIntDaysColNum:\t %d \n",ConfigTable.NotIntDaysColNum);
    printf("NotIntDays:\t %d \n",ConfigTable.NotIntDays);
    printf("NotIntHrsColNum:\t %d \n",ConfigTable.NotIntHrsColNum);
    printf("NotIntHrs:\t %d \n",ConfigTable.NotIntHrs);
    printf("NotIntMinsColNum:\t %d \n",ConfigTable.NotIntMinsColNum);
    printf("NotIntMins:\t %d \n",ConfigTable.NotIntMins);
    printf("StartDate:\t %s \n",ConfigTable.StartDate);
    printf("StartTime:\t %s \n",ConfigTable.StartTime);
    printf("DbpathColNum:\t %d \n",ConfigTable.DbpathColNum);
    printf("Dbpath:\t %s \n",ConfigTable.Dbpath);
    printf("DbnameColNum:\t %d \n",ConfigTable.DbnameColNum);
    printf("Dbname:\t %s \n",ConfigTable.Dbname);
    printf("VFactorColNum:\t %d \n",ConfigTable.VFactorColNum);
    printf("VFactor:\t %d \n",ConfigTable.VFactor);
    printf("StoreDateColNum:\t %d \n",ConfigTable.StoredDateColNum);
    printf("StoredDate:\t %s \n",ConfigTable.StoredDate);
    printf("NumLevelsColNum:\t %d \n",ConfigTable.NumLevelsColNum);
    printf("NumLevels:\t %d \n",ConfigTable.NumLevels);
    printf("NSchDateColNum:\t %d \n",ConfigTable.NSchDateColNum);
    printf("NSchDate:\t %s \n",ConfigTable.NSchDate);
    printf("++++++++++++++++++++++++++\n");
}

/* Added by Huilong on 5/30/2007
 * Check the existing tampering in the control database
 */
int checkExistingTampering(SQLHDBC dbc)
{
    SQLHSTMT stmt;

    SQLRETURN sqlret; /* ODBC API return status */

    SQLINTEGER indicator;

    SQLSMALLINT columns; /* number of columns in result-set */

    SQLCHAR getTampering[SQLQUERY] = "select EventID from Event where Kind='T'";
    
    char buf[MAXEVENTBUF];
    int ret;     

    strcat(getTampering, " and Path='");
    strcat(getTampering, ConfigTable.Dbpath);
    strcat(getTampering, "' ");
    strcat(getTampering, " and Name='");
    strcat(getTampering, ConfigTable.Dbname);
    strcat(getTampering, "'");
    /* Allocate a statement handle */
    SQLAllocHandle(SQL_HANDLE_STMT, dbc, &stmt);
    //get EventID(foreign key) from Event table first
    sqlret = SQLExecDirect(stmt,getTampering,SQL_NTS);
    if (sqlret == SQL_SUCCESS) {
            sqlret = SQLFetch(stmt);
            if (ret == SQL_SUCCESS || ret == SQL_SUCCESS_WITH_INFO) {
                if (SQL_SUCCEEDED(SQLGetData(stmt, 1, SQL_C_CHAR,
                              buf, MAXEVENTBUF, &indicator))) {
                      return 1;
                }
            }
    }

    return 0;

}    


void getNIDfromChain(SQLHDBC dbc, char *nid_value, char *EventID) {
    SQLHSTMT stmt;
    SQLRETURN ret; // ODBC API return status 
    SQLSMALLINT columns; // number of columns in result-set 
    int row = 0;
    SQLINTEGER indicator;
    char buf[512];
    SQLUSMALLINT i=1;
    SQLCHAR getNID[SQLQUERY] = "select NotarID from Chain where Color='black' AND EventID=";
    int FindEvent = 0;

    //int oldstrlen = strlen(getNID);
    //strncat(getNID,hash_value,AUD_HASH_LEN);
    //getNID[oldstrlen+AUD_HASH_LEN+1] = '\0';

    strcat(getNID,EventID);

    // Allocate a statement handle
    SQLAllocHandle(SQL_HANDLE_STMT, dbc, &stmt);

    //get Configuration Column names
    ret = SQLExecDirect(stmt,getNID,SQL_NTS);
    printf("getNIDfromChain:%s\n",getNID);

    bzero(nid_value,AUD_HASH_LEN);
    if (ret == SQL_SUCCESS) {
        while (1) {
            ret = SQLFetch(stmt);
            if (ret == SQL_ERROR || ret == SQL_SUCCESS_WITH_INFO) {
                //show_error();
               fprintf(stderr, "err in db fetching: %d\n", ret);
               exit(1);
            }

            if (ret == SQL_SUCCESS || ret == SQL_SUCCESS_WITH_INFO) {
                FindEvent = 1;

                SQLUSMALLINT i = 1;

                // How many columns are there
                SQLNumResultCols(stmt, &columns);

                // Loop through the columns
                for (i = 1; i <= columns; i++) {

                    // retrieve column data as a string
                    if (SQL_SUCCEEDED(SQLGetData(stmt, i, SQL_C_CHAR,
                              buf, sizeof(buf), &indicator))) {
                            str_to_value(buf,2*AUD_HASH_LEN,nid_value,AUD_HASH_LEN);
//sprintf(nid_value,"%s",nid_value);
//                      strcpy(nid_value,buf);
                    }
                }
            } else {
                break;
            }
        }
   }
   if (!FindEvent) {
        insErrEvent(dbc,"Can't find NID for this Event\n");
        fprintf(stderr,"Can't find NID for this Event\n");
        exit(1);
   }

}

