#ifndef __COMMON_H__
#define __COMMON_H__

/*ODBC support*/
#include <sql.h>
#include <sqlext.h>

#define MAXSQLQUERY 256
#define SQLQUERY 256

#define DBPATHLEN 512 // used to be 256
#define DBNAMELEN 36

//#define TIMESTAMPLEN 40
//#define DBDATELEN 20
//#define DBTIMELEN 20

#define MAXEVENTBUF 40

#define MAXERREVT 700
#define ERRORINFO 500

// time use
#define TIMESTPLEN 60
#define DATELEN 30
#define MSLEN 12
#define IDLEN MSLEN

// insert query use
#define MAXINSLEN 350

// email address length, defined the same as database
#define EMAILLEN 35


// file name len
#define FILENAMELEN	100

typedef struct Config
{
    int AlgColNum;
    char Algorithm[35];

    int NotIntDaysColNum;
    int NotIntDays;

    int NotIntHrsColNum;
    int NotIntHrs;

    int NotIntMinsColNum;
    int NotIntMins;

//    int StartDateColNum;  // get value from Event table for Kind="C"
    char StartDate[DATELEN];

//    int StartTimeColNum;
    char StartTime[DATELEN];

    int DbpathColNum;
    char Dbpath[DBPATHLEN];

    int DbnameColNum;
    char Dbname[DBNAMELEN];

    int NumLevelsColNum;
    int NumLevels;

    int VFactorColNum;
    int VFactor;

    int StoredDateColNum;
    char StoredDate[TIMESTPLEN];

    int NSchDateColNum;
    char NSchDate[TIMESTPLEN];
} CONFIG;

CONFIG ConfigTable;



void show_error(int source);
void getCreateID(SQLHDBC dbc,char *dbCreateID);
int getPreNotID(SQLHDBC dbc, char *preNotID, char *curNotID);
int getMaxValEvent(SQLHDBC dbc, char *preValSchDate,char *preValActDate,char *preValActMs);
int cmpSchDate(char *SchDate);
void exeSqlQuery(SQLHDBC dbc, char *insertSql);
void getMaxNotID(SQLHDBC dbc,char *maxNotID);
int getAvaAtID(SQLHDBC dbc);
void getTimestp(char *timestp, char *date, char *time);
void ErrorCheck(void);
void getDate(char *timestp, char *date, char *time);
void insErrEvent(SQLHDBC dbc, char *errinfo);
void getStartDate(SQLHDBC dbc);
void ReadConf(SQLHDBC dbc);
void setConfigTable(char *buf,int i);
void getConfigTablerow(char *buf,int row);
void InitConfigTable();
void PrintConfigTable();
void getNIDfromChain(SQLHDBC dbc, char *nid_value, char *EventID);

struct timeval mkCalTime(char *date, char *time, char *ms);

#endif
