#ifndef __DNSVERIFIER_H__
#define __DNSVERIFIER_H__

#include <sql.h>
#include <sqlext.h>
#include "db.h"
#include <sys/times.h>

#define LOCAL_VERIFICATION 0
#define SURETY_VERIFICATION 1
#define ATCOMLEN 512

typedef struct VerificationParameter {
  int method; // LOCAL_VERIFICATION, SURETY_VERIFICATION
  SQLHDBC dbc;
  char* binary_dir;
  char* server_name;
  char* surety_user_name;
  char* surety_password;
  char* hash_value;
  char* notarization_id;
  struct timeval ttime;
  NID nid_output;
} VerificationParameter;

int DoVerification(VerificationParameter* ver_param);

void CommunicateWithDNS(VerificationParameter* ver_param);

#endif
