#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/time.h>
#include <time.h>

int main(int argc, char **argv){
   struct stat stat_p;
   int seed, file_len, page_size; // in bytes
   int fid, rand_pos; 
   unsigned char orig_byte, new_byte;
   struct timeval cur_t;
   char  cur_t_str[256];

   //check the arguments
   if(argc!=3){
      printf("Usage: %s db_file_name position(oct)\n", argv[0]);
      exit(1);
   }
   
   //get the file length
   stat(argv[1], &stat_p);
   file_len = stat_p.st_size;
   page_size = stat_p.st_blksize;

   //get the specified position
   sscanf(argv[2],"%o", &rand_pos);  
   if(rand_pos>file_len){
      printf("The specified position is greater than file length!\n");
      exit(1);
   }
  
   // open the file
   fid = open(argv[1], O_RDWR);
   if(fid<0){
      printf("Can not open file %s\n", argv[1]);
      exit(1);
   }
   
   // go to the random position and change the byte
   if(lseek(fid,rand_pos,SEEK_SET)<0){
      printf("Fail to seek the position %o\n", rand_pos);
      exit(1);
   }
   
   // get the byte
   if(read(fid, &orig_byte, 1)<=0){
      printf("Error in read a byte!\n");
      exit(1);
   }
   
   // change it and write back
   new_byte = orig_byte ^ 0xFF;
   
   // write the byte back
   lseek(fid,-1, SEEK_CUR);
   if(write(fid,&new_byte, 1)<=0){
      printf("Error in change a byte!\n");
      exit(1);
   }

   gettimeofday(&cur_t,NULL);
   strftime(cur_t_str,30,"%Y-%m-%d %X",localtime(&(cur_t.tv_sec)));
 
   // close the file
   if(close(fid)<0){
      printf("Error in close!\n");
      exit(1);
   }
   
   // print the change
   printf("Time %s, File:%s,a byte at pos:%o(oct) changed from %x to %x!\n", 
          cur_t_str, argv[1], rand_pos,  orig_byte, new_byte);
   
   return 0;
}

