#include <stdio.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <unistd.h>
#include "sha1.h"
#include "memchunk.h"

#define HASH_LEN 20

typedef struct sockaddr_in SAI;
typedef struct sockaddr SA;
typedef struct timeval TV;

/* Keep this consistent with the one in aud_int.h !!! */
struct __nid {
    TV ntime;
    char nid[20];
};
typedef struct __nid NID;

int interval = 2;

int main(int argc, char *argv[])
{
    int sockfd;
    in_port_t port;
    SAI servaddr, cliaddr;
    SA *pcliaddr;
    socklen_t len;
    int n;
    char mesg[HASH_LEN];

    if (argc != 2) {
	fprintf(stderr, "Usage: %s interval\n", argv[0]);
	exit(1);
    }

//    port = atoi(argv[1]);
    port = 11111;
    printf("Port = %d\n", port);
//    interval = atoi(argv[2]);
    interval = atoi(argv[1]);
    printf("Interval = %d\n", interval);

    sockfd = socket(AF_INET, SOCK_DGRAM, 0);
    memset(&servaddr, 0, sizeof(servaddr));
    servaddr.sin_family = AF_INET;
    servaddr.sin_addr.s_addr = htonl(INADDR_ANY);
    servaddr.sin_port = htons(port);

    bind(sockfd, (SA *)&servaddr, sizeof(servaddr));

    pcliaddr = (SA *)&cliaddr;

    for (;;) {
	sha1Param param;
	NID id;

	/* Receive from the client */
	len = sizeof(cliaddr);
	n = recvfrom(sockfd, mesg, HASH_LEN, 0, pcliaddr, &len);
	printf("Got a request\n");
//        print_hash(mesg);	
	/* Do the hashing */
	if (sha1Reset(&param))
	    return -1;
	if (sha1Update(&param, mesg, HASH_LEN))
	    return -1;
	if (sha1Digest(&param, id.nid))
	    return -1;
	gettimeofday(&id.ntime, NULL);
	printf("  The request is processed, time=(%u, %u)\n",
	       id.ntime.tv_sec, id.ntime.tv_usec);

	/* Simulate the network delay */
	sleep(interval);
	
	/* Send back the N-ID */
//        print_hash(id.nid);
	sendto(sockfd, &id, sizeof(id), 0, pcliaddr, len);
	printf("  The nId is returned\n");
    }
}
