-- MySQL dump 10.11
--
-- Host: mysql    Database: tau
-- ------------------------------------------------------
-- Server version	5.0.27-log

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `Chain`
--

DROP TABLE IF EXISTS `Chain`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `Chain` (
  `EventID` int(11) NOT NULL,
  `Level` tinyint(4) NOT NULL default '0',
  `Color` varchar(15) NOT NULL default '',
  `ChainID` int(10) unsigned NOT NULL auto_increment,
  `StartMilliseconds` int(11) default NULL,
  `StopMilliseconds` int(11) default NULL,
  `Hashcode` char(40) default NULL,
  `NotarID` char(40) default NULL,
  `StartDate` timestamp NOT NULL default '0000-00-00 00:00:00',
  `StopDate` timestamp NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`ChainID`)
) ENGINE=MyISAM AUTO_INCREMENT=9467 DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `Chain`
--

LOCK TABLES `Chain` WRITE;
/*!40000 ALTER TABLE `Chain` DISABLE KEYS */;
/*!40000 ALTER TABLE `Chain` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `Configuration`
--

DROP TABLE IF EXISTS `Configuration`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `Configuration` (
  `StoredDate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `NotIntDays` tinyint(4) NOT NULL,
  `NotIntHrs` tinyint(4) NOT NULL,
  `NotIntMins` tinyint(4) NOT NULL,
  `ValidationFactor` tinyint(4) NOT NULL,
  `Algorithm` varchar(35) NOT NULL,
  `NumLevels` tinyint(4) NOT NULL,
  `Name` char(512) NOT NULL,
  `Path` char(1024) NOT NULL default '',
  `NotarizationScheduledDate` timestamp NOT NULL default '1970-01-01 07:00:00',
  PRIMARY KEY  (`StoredDate`,`Name`,`Path`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `Configuration`
--

LOCK TABLES `Configuration` WRITE;
/*!40000 ALTER TABLE `Configuration` DISABLE KEYS */;
/*!40000 ALTER TABLE `Configuration` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `Employee`
--

DROP TABLE IF EXISTS `Employee`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `Employee` (
  `Name` varchar(512) NOT NULL default '',
  `Email` varchar(35) NOT NULL default '',
  `isCSO` enum('Y','N') NOT NULL,
  `isDBA` enum('Y','N') NOT NULL,
  `isCSI` enum('Y','N') NOT NULL,
  `Password` varchar(10) NOT NULL,
  `PhoneNumber` varchar(35) NOT NULL,
  `StartDate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `Stopdate` timestamp NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`Email`,`StartDate`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `Employee`
--

LOCK TABLES `Employee` WRITE;
/*!40000 ALTER TABLE `Employee` DISABLE KEYS */;
INSERT INTO `Employee` VALUES ('jimbob','jimbob@acme.com','Y','Y','Y','tbdb','520-1234567','2007-04-27 21:44:18','0000-00-00 00:00:00');
/*!40000 ALTER TABLE `Employee` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `Event`
--

DROP TABLE IF EXISTS `Event`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `Event` (
  `Kind` enum('C','E','N','T','V') default NULL,
  `Info` varchar(500) default NULL,
  `EventID` int(11) NOT NULL auto_increment,
  `Path` char(1024) default NULL,
  `Name` char(512) default NULL,
  `ActualMilliseconds` int(11) default NULL,
  `atID` int(11) default NULL,
  `ActualDate` timestamp NOT NULL default '0000-00-00 00:00:00',
  `ScheduledDate` timestamp NOT NULL default '0000-00-00 00:00:00',
  UNIQUE KEY `EventID` (`EventID`)
) ENGINE=MyISAM AUTO_INCREMENT=15848 DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `Event`
--

LOCK TABLES `Event` WRITE;
/*!40000 ALTER TABLE `Event` DISABLE KEYS */;
/*!40000 ALTER TABLE `Event` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `IsMaintainedBy`
--

DROP TABLE IF EXISTS `IsMaintainedBy`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `IsMaintainedBy` (
  `StartDate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `Email` varchar(35) NOT NULL default '',
  `Kind` enum('A','C','D') NOT NULL,
  `Name` char(512) NOT NULL default '',
  `Path` char(1024) NOT NULL default '',
  `StopDate` timestamp NULL default NULL,
  PRIMARY KEY  (`StartDate`,`Email`,`Name`,`Path`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `IsMaintainedBy`
--

LOCK TABLES `IsMaintainedBy` WRITE;
/*!40000 ALTER TABLE `IsMaintainedBy` DISABLE KEYS */;
/*!40000 ALTER TABLE `IsMaintainedBy` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `NotarizationCheck`
--

DROP TABLE IF EXISTS `NotarizationCheck`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `NotarizationCheck` (
  `ChainID` int(11) NOT NULL default '0',
  `Result` enum('P','F') NOT NULL,
  `FailureID` int(11) NOT NULL default '0',
  PRIMARY KEY  (`ChainID`,`FailureID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `NotarizationCheck`
--

LOCK TABLES `NotarizationCheck` WRITE;
/*!40000 ALTER TABLE `NotarizationCheck` DISABLE KEYS */;
/*!40000 ALTER TABLE `NotarizationCheck` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `SynchronizedRegion`
--

DROP TABLE IF EXISTS `SynchronizedRegion`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `SynchronizedRegion` (
  `TopLeftX` int(11) NOT NULL default '0',
  `TopLeftY` int(11) NOT NULL default '0',
  `TopRightX` int(11) default NULL,
  `TopRightY` int(11) default NULL,
  `BottomLeftX` int(11) default NULL,
  `BottomLeftY` int(11) default NULL,
  `BottomRightX` int(11) default NULL,
  `BottomRightY` int(11) default NULL,
  `EventID` int(11) NOT NULL default '0',
  PRIMARY KEY  (`EventID`,`TopLeftX`,`TopLeftY`),
  KEY `TopLeftY` (`TopLeftY`),
  KEY `TopRightX` (`TopRightX`),
  KEY `BottomLeftX` (`BottomLeftX`),
  KEY `BottomLeftY` (`BottomLeftY`),
  KEY `BottomRightX` (`BottomRightX`),
  KEY `BottomRightY` (`BottomRightY`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `SynchronizedRegion`
--

LOCK TABLES `SynchronizedRegion` WRITE;
/*!40000 ALTER TABLE `SynchronizedRegion` DISABLE KEYS */;
/*!40000 ALTER TABLE `SynchronizedRegion` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `UnsynchronizedRegion`
--

DROP TABLE IF EXISTS `UnsynchronizedRegion`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `UnsynchronizedRegion` (
  `EventID` int(11) NOT NULL,
  `TopLeftX` timestamp NOT NULL default '0000-00-00 00:00:00',
  `TopLeftY` timestamp NOT NULL default '0000-00-00 00:00:00',
  `TopRightX` timestamp NOT NULL default '0000-00-00 00:00:00',
  `TopRightY` timestamp NOT NULL default '0000-00-00 00:00:00',
  `BottomLeftX` timestamp NOT NULL default '0000-00-00 00:00:00',
  `BottomLeftY` timestamp NOT NULL default '0000-00-00 00:00:00',
  `BottomRightX` timestamp NOT NULL default '0000-00-00 00:00:00',
  `BottomRightY` timestamp NOT NULL default '0000-00-00 00:00:00',
  `TopLeftXMillisecond` int(11) NOT NULL,
  `TopLeftYMillisecond` int(11) NOT NULL,
  `TopRightXMillisecond` int(11) NOT NULL,
  `TopRightYMillisecond` int(11) NOT NULL,
  `BottomLeftXMillisecond` int(11) NOT NULL,
  `BottomLeftYMillisecond` int(11) NOT NULL,
  `BottomRightXMillisecond` int(11) NOT NULL,
  `BottomRightYMillisecond` int(11) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `UnsynchronizedRegion`
--

LOCK TABLES `UnsynchronizedRegion` WRITE;
/*!40000 ALTER TABLE `UnsynchronizedRegion` DISABLE KEYS */;
/*!40000 ALTER TABLE `UnsynchronizedRegion` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cost`
--

DROP TABLE IF EXISTS `cost`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `cost` (
  `digital_notarization_signing` float default NULL,
  `digital_notarization_checks` float default NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `cost`
--

LOCK TABLES `cost` WRITE;
/*!40000 ALTER TABLE `cost` DISABLE KEYS */;
INSERT INTO `cost` VALUES (1,1);
/*!40000 ALTER TABLE `cost` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `state_lookup`
--

DROP TABLE IF EXISTS `state_lookup`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `state_lookup` (
  `country_id` varchar(10) NOT NULL default '0',
  `state_id` varchar(10) NOT NULL,
  `statedesc` varchar(50) default NULL,
  PRIMARY KEY  (`country_id`,`state_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
SET character_set_client = @saved_cs_client;

--
-- Dumping data for table `state_lookup`
--

LOCK TABLES `state_lookup` WRITE;
/*!40000 ALTER TABLE `state_lookup` DISABLE KEYS */;
/*!40000 ALTER TABLE `state_lookup` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2010-03-02 17:42:06
